Package: SpatialExperimentIO
Title: Read in Xenium, CosMx, MERSCOPE or STARmapPLUS data as
        SpatialExperiment object
Version: 1.5.0
Authors@R: c(
    person("Yixing E.", "Dong", 
        email = "estelladong729@gmail.com", 
        role = c("aut", "cre"), 
        comment = c(ORCID = "0009-0003-5115-5686")))
URL: https://github.com/estellad/SpatialExperimentIO
BugReports: https://github.com/estellad/SpatialExperimentIO/issues
Description: Read in imaging-based spatial transcriptomics technology data. Current available modules are for Xenium by 10X Genomics, CosMx by Nanostring, MERSCOPE by Vizgen, or STARmapPLUS from Broad Institute. You can choose to read the data in as a SpatialExperiment or a SingleCellExperiment object. 
License: Artistic-2.0
Encoding: UTF-8
VignetteBuilder: knitr
Roxygen: list(markdown = TRUE)
Imports: DropletUtils, SpatialExperiment, SingleCellExperiment,
        methods, data.table, arrow, purrr, S4Vectors
Suggests: knitr, rmarkdown, testthat (>= 3.0.0), BiocStyle
biocViews: DataRepresentation, DataImport, Infrastructure,
        Transcriptomics, SingleCell, Spatial, GeneExpression
RoxygenNote: 7.3.2
Config/testthat/edition: 3
git_url: https://git.bioconductor.org/packages/SpatialExperimentIO
git_branch: devel
git_last_commit: 56f593f
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-29
NeedsCompilation: no
Packaged: 2026-04-30 00:34:26 UTC; biocbuild
Author: Yixing E. Dong [aut, cre] (ORCID:
    <https://orcid.org/0009-0003-5115-5686>)
Maintainer: Yixing E. Dong <estelladong729@gmail.com>
Depends: R (>= 4.1.0)

# Introduction

<img src="inst/extdata/SpatialExperimentIO.png" width="200" align="right"/>

The `SpatialExperimentIO` package provides a set of functions to import Xenium (10x Genomics), CosMx (Nanostring), MERSCOPE (Vizgen), STARmapPLUS (Wang et al., 2023, Broad Institute), and seqFISH (Spatial Genomics) data into a `SpatialExperiment` or `SingleCellExperiment`class object.

# Installation

``` r
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install("SpatialExperimentIO")
```

# Development version

You can also install the development version of *SpatialExperimentIO* from [GitHub](https://github.com/estellad/SpatialExperimentIO) with:

``` r
# install.packages("devtools")
devtools::install_github("estellad/SpatialExperimentIO", ref = "devel")
```

# Load package

``` r
library(SpatialExperimentIO)
```

# Xenium ouptut folder structure

A standard Xenium output folder should contain these files for the function `readXeniumSXE()`. `cells.parquet` or `cells.csv.gz`, as well as either `cell_feature_matrix.h5` or `/cell_feature_matrix` are required for just a count matrix at cell-level and its column data. Other transcript, cell/nucleus boundaries, and experiment.xenium .parquet files will have their paths added to `metadata()`. Genes that are served as control probes can be moved to `altExp()` by specifying their gene name patterns in the reader `readXeniumSXE()`. 

```         
    Xenium_unzipped
        └── outs 
            ├── cells.parquet 
            ├── cell_feature_matrix.h5 
            └── cell_feature_matrix 
                ├── barcodes.tsv 
                ├── features.tsv 
                └── matrix.mtx
            ├── transcripts.parquet 
            ├── cell_boundaries.parquet     
            ├── nucleus_boundaries.parquet  
            └── experiment.xenium
```

# CosMx output folder structure

A standard CosMx output folder should contain these files for the function `readCosMxSXE()`. Both `metadata_file.csv` and `exprMat_file.csv` are required for just a count matrix at cell-level and its column data. Additional data `fov_positions_file.csv` can be merged to `colData()`. Other transcript and polygon .csv files will be convert and write to .parquet files, and will have their parquet paths added to `metadata()`. Genes that are served as control probes can be moved to `altExp()` by specifying their gene name patterns in the reader `readCosMxSXE()`. 

```         
    CosMx 
        ├── metadata_file.csv 
        ├── exprMat_file.csv
        ├── fov_positions_file.csv
        ├── tx_file.csv
        └── polygons.csv
        
```

# MERSCOPE output folder structure

A standard MERSCOPE output folder should contain these files for the function `readMerscopeSXE()`. Both `cell_metadata.csv` and `cell_by_gene.csv` are required for just a count matrix at cell-level and its column data. Cell boundaries are multiple .h5 files that are yet to be processed by `SpatialExperimentIO`. Transcript.csv files are available and is yet to be added as path to parquet in `SpatialExperimentIO`.

```         
    MERSCOPE 
        ├── cell_metadata.csv 
        └── cell_by_gene.csv
```

# STARmap PLUS output folder structure

A standard STARmap PLUS output folder should contain these files for the function `readStarmapplusSXE()`. Both `spatial.csv` and `raw_expression_pd.csv` are required for just a count matrix at cell-level and its column data.

```         
    STARmap_PLUS 
        ├── spatial.csv 
        └── raw_expression_pd.csv
```

# seqFISH output folder structure

A standard seqFISH output folder should contain these files for the function `readSeqfishSXE()`. Both `CellCoordinates.csv` and `CellxGene.csv` are required for just a count matrix at cell-level and its column data.

```         
    seqFISH 
        ├── CellCoordinates.csv 
        └── CellxGene.csv
```

# Usage

Taking Xenium as an example, providing a path to the folder that stores all the required files (i.e. `/outs` ) would return a `SpatialExperiment` object.

``` r
spe <- readXeniumSXE(dir)
spe
# class: SpatialExperiment 
# dim: 4 6 
# metadata(0):
# assays(1): counts
# rownames(4): AATK ABL1 ACKR3 ACKR4
# rowData names(3): ID Symbol Type
# colnames(6): 1 2 ... 5 6
# colData names(9): X cell_id ... nucleus_area sample_id
# reducedDimNames(0):
# mainExpName: NULL
# altExpNames(0):
# spatialCoords names(2) : x_centroid y_centroid
# imgData names(0):
```

################################################################################
# Script to create a small .h5 count matrix and a small cells.csv.gz files 
# from the raw download of the Xenium 1 human breast cancer
# in 10x Xenium paper by Janesick et al. (2023)
# Yixing Dong, updated Aug 2024
################################################################################

# references:
# XeniumOutputBundle .zip file was downloaded from 
# \url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSM7780153}

# in this script we subset the large raw necessary files into small ones.

# -------------
# Download data
# -------------

# In the 10X Xenium paper, the Xenium sample 1 (2 replicates) data was accompanied 
# by consecutive slices of Chromium and Visium replicates. 

# We first prepare the data folder required by reader function `SpatialExperimentIO::readXeniumSXE()`. 
# Please click to download [Xenium Sample 1 Replicate 1 outs](https://www.ncbi.nlm.nih.gov/geo/download/?acc=GSM7780153&format=file&file=GSM7780153%5FXenium%5FFFPE%5FHuman%5FBreast%5FCancer%5FRep1%5Fouts%2Ezip). 
# Here we placed the downloaded objects in `here::here("/raw_data/xenium_sample1rep1/")`. 

xenium_out_folder <- list.files(here::here("raw_data/xenium_sample1rep1"), pattern = ".zip")
xenium_out_folder


# We now unzip `spatial.tar.gz` to its same directory. 

unzip(file.path(here::here("raw_data/xenium_sample1rep1"), xenium_out_folder),
      exdir = here::here("raw_data/xenium_sample1rep1"))


# Have a look at all the files in the newly unzipped `/outs` folder. The only 
# files you need are `cell_feature_matrix.h5` or `cell_feature_matrix`, and 
# `cells.csv.gz`. 

list.files(here::here("raw_data/xenium_sample1rep1/outs"))

# Sanity check that the files you need are in the `/outs` folder.

all(c("cell_feature_matrix.h5", "cell_feature_matrix", "cells.csv.gz") %in% 
      list.files(here::here("raw_data/xenium_sample1rep1/outs")))


# -------------
# Read raw .h5 file
# -------------

# First, we need to install the `rhdf5` loader package that would 
# read the .h5 object: 

# if (!require("BiocManager", quietly = TRUE))
#   install.packages("BiocManager")
# BiocManager::install("rhdf5")

library(rhdf5)

h5file <- "~/Desktop/SampleData/archive/Xenium_Preprint_Data/Xenium/outs/cell_feature_matrix.h5"
h5ls(file = h5file)


# -------------
# Downsize to 4 genes, 6 cells small .h5 for each sub-level of .h5
# -------------

h5_barcodes = h5read(h5file, "/matrix/barcodes")
h5_barcodes_new <- as(head(h5_barcodes), class(h5_barcodes)) #1 2 3 4 5 6 # take only 6 cells

h5_data = h5read(h5file, "/matrix/data")
# matrix(c(0, 2:6, 0, 8:10, 0, 0, 0, 14:15, 0, 17:18, 0, 20, 0, 2:3, 0), nrow = 4, ncol = 6) # something like this
# https://www.10xgenomics.com/support/software/cell-ranger/latest/analysis/outputs/cr-outputs-h5-matrices
h5_data_new <- c(2, 3, 4, 5, 6, 8, 9, 10, 14, 15, 17, 18, 20, 2, 3) # int 1 1 1 3 2 4  # Nonzero UMI counts in column-major order


## Features
h5_all_tag_keys = h5read(h5file, "/matrix/features/_all_tag_keys")
h5_all_tag_keys_new <- h5_all_tag_keys # "genome"

h5_feature_type = h5read(h5file, "/matrix/features/feature_type")
h5_feature_type_new <- head(h5_feature_type, 4) # "Gene Expression" # take only 4 genes

h5_genome = h5read(h5file, "/matrix/features/genome")
h5_genome_new <- head(h5_genome, 4) # "Unknown" # take only 4 genes

h5_id = h5read(h5file, "/matrix/features/id")
h5_id_new <- head(h5_id, 4) # "ENSG000121270" # take only 4 genes

h5_name = h5read(h5file, "/matrix/features/name")
h5_name_new <- head(h5_name, 4) # "ABCC11" # take only 4 genes

# matrix
h5_indices = h5read(h5file, "/matrix/indices")
h5_indices_new <- h5_data_new <- c(1, 2, 3, 0, 1, 3, 0, 1, 1, 2, 0, 1, 3, 1, 2) # int 33 36 67  # Zero-based row index of corresponding element in `data`

h5_indptr = h5read(h5file, "/matrix/indptr")
h5_indptr_new <- c(0, 3, 6, 8, 10, 13, 15) # int 33 36 67 # take 6 cells, # Zero-based index into data / indices of the start of each column, 
# i.e., the data corresponding to each barcode sequence
# https://stackoverflow.com/questions/52299420/scipy-csr-matrix-understand-indptr

h5_shape = h5read(h5file, "/matrix/shape")
h5_shape_new <- h5_shape # 541 167780
h5_shape_new[1] <- 4
h5_shape_new[2] <- 6


# -------------
# How orignal .h5 looks like
# -------------

#               group          name       otype  dclass      dim
# 0                 /        matrix   H5I_GROUP                 
# 1           /matrix      barcodes H5I_DATASET  STRING   167780
# 2           /matrix          data H5I_DATASET INTEGER 10640759
# 3           /matrix      features   H5I_GROUP                 
# 4  /matrix/features _all_tag_keys H5I_DATASET  STRING        1
# 5  /matrix/features  feature_type H5I_DATASET  STRING      541
# 6  /matrix/features        genome H5I_DATASET  STRING      541
# 7  /matrix/features            id H5I_DATASET  STRING      541
# 8  /matrix/features          name H5I_DATASET  STRING      541
# 9           /matrix       indices H5I_DATASET INTEGER 10640759
# 10          /matrix        indptr H5I_DATASET INTEGER   167781
# 11          /matrix         shape H5I_DATASET INTEGER        2


# -------------
# Format and write my small .h5
# -------------

smallh5 <- "~/Desktop/SampleData/SpatialExperimentIOData/Xenium/cell_feature_matrix.h5"

h5createFile(smallh5)
h5createGroup(smallh5,"matrix")
h5createGroup(smallh5,"matrix/features")
h5ls(smallh5)

h5write(h5_barcodes_new, smallh5,"matrix/barcodes")
h5write(h5_data_new, smallh5,"matrix/data")

h5write(h5_all_tag_keys_new, smallh5,"matrix/features/_all_tag_keys")
h5write(h5_feature_type_new, smallh5,"matrix/features/feature_type")
h5write(h5_genome_new, smallh5,"matrix/features/genome")
h5write(h5_id_new, smallh5,"matrix/features/id")
h5write(h5_name_new, smallh5,"matrix/features/name")

h5write(h5_indices_new, smallh5,"matrix/indices")
h5write(h5_indptr_new, smallh5,"matrix/indptr")
h5write(h5_shape_new, smallh5,"matrix/shape")
h5ls(smallh5)


# -------------
# Check if raw and small .h5 can be read as a SingleCellExperiment
# -------------

# Now try to read it as SCE

library(SingleCellExperiment)
# chromh5 <- "~/Desktop/SampleData/archive/Xenium_Preprint_Data/Chromium_FFPE_Human_Breast_Cancer_Chromium_FFPE_Human_Breast_Cancer/count_sample_filtered_feature_bc_matrix.h5"

sce <- DropletUtils::read10xCounts(h5file, type = "HDF5", col.names = TRUE)
# sce <- DropletUtils::read10xCounts(chromh5, type = "HDF5", col.names = TRUE)
scetest <- SingleCellExperiment::SingleCellExperiment(assays = assays(sce))
counts(scetest)[34:38,]

sce <- DropletUtils::read10xCounts(smallh5, type = "HDF5", col.names = TRUE)
scetest <- SingleCellExperiment::SingleCellExperiment(assays = assays(sce))

data_check <- counts(sce)


# -------------
# Create small metadata
# -------------

# install.packages("dplyr")
library(dplyr)

# Read un .gz ed cell.csv

cells <- read.csv("~/Desktop/SpatialExperimentIO/inst/extdata/Xenium_small/cells.csv")

# Subset to 6 cells

cells <- cells %>% slice(1:6)

# Save the subset

write.csv(cells, "~/Desktop/SpatialExperimentIO/inst/extdata/Xenium_small/cells.csv")

# Now manually zipped it to have `cells.csv.gz` in ./inst/extdata/Xenium_small/


# -------------
# Sanity check
# -------------

# install necessary packages

devtools::install_github("estellad/SpatialExperimentIO")
remotes::install_github("lmweber/ggspavis")

# load packages

library(SpatialExperimentIO)
library(ggspavis)

# read the small .h5 and cells.csv.gz as SPE object, and plot it. 

spe <- readXeniumSXE(dirName = "~/Desktop/SpatialExperimentIO/inst/extdata/Xenium_small/", returnType = "SPE")
plotSpots(spe, annotate = "total_counts", in_tissue = NULL)


sce <- DropletUtils::read10xCounts("~/Desktop/SpatialExperimentIO/inst/extdata/Xenium_small/cell_feature_matrix.h5", 
                                   type = "HDF5", col.names = TRUE)

rownames(sce) <- rowData(sce)$Symbol

four_genes <- c("ABCC11", "ACTA2", "ACTG2", "ADAM9")
six_cells <- 1:6


# -------------
# Create small nucleus boundaries
# -------------
filepaths <- "~/Downloads/BC_data/Xenium_rep1/"
nucboundname <- "nucleus_boundaries.parquet"
cellboundname <- "cell_boundaries.parquet"
txname <- "transcripts.parquet"
cellsname <- "cells.parquet"

xe_small_path <- "~/Desktop/SpatialExperimentIO/inst/extdata/Xenium_small"

nucbound <- arrow::read_parquet(file.path(filepaths, nucboundname))
nucbound_test <- nucbound %>% filter(cell_id %in% six_cells)
arrow::write_parquet(nucbound_test, file.path(xe_small_path, nucboundname))  

cellbound <- arrow::read_parquet(file.path(filepaths, cellboundname))
cellbound_test <- cellbound %>% filter(cell_id %in% six_cells)
arrow::write_parquet(cellbound_test, file.path(xe_small_path, cellboundname))  

tx <- arrow::read_parquet(file.path(filepaths, txname), as_data_frame=FALSE)
tx <- tx |>
  mutate(feature_name=as.character(feature_name)) |>
  mutate(transcript_id=as.numeric(transcript_id)) |>
  as.data.frame()
tx_test <- tx %>% filter(cell_id %in% six_cells & feature_name %in% four_genes)
arrow::write_parquet(tx_test, file.path(xe_small_path, txname))  

cells <- arrow::read_parquet(file.path(filepaths, cellsname))
cells_test <- cells %>% filter(cell_id %in% six_cells)
arrow::write_parquet(cells_test, file.path(xe_small_path, cellsname))  

## Sanity
# extdatapath <- "~/Desktop/SpatialExperimentIO/inst/extdata/Xenium_small/"
# tx <- arrow::read_parquet(file.path(extdatapath, txname))
# cells <- arrow::read_parquet(file.path(extdatapath, cellsname))
# cells <- arrow::read_parquet(file.path(extdatapath, cellsname))

#' @rdname readSeqfishSXE
#' 
#' @title Load data from a Spatial Genomics seqFISH experiment
#' 
#' @description
#' Creates a \code{\link{SpatialExperiment}} from the downloaded seqFISH   
#' directory for Spatial Genomics seqFISH spatial gene expression data.
#'
#' @param dirName a directory path to seqFISH download that contains files of interest.
#' @param returnType option of \code{"SPE"} or \code{"SCE"}, stands for 
#' \code{SpatialExperiment} or \code{SingleCellExperiment} object. Default value \code{"SPE"}
#' @param countMatPattern a filename pattern for the count matrix. Default value is 
#' \code{"CellxGene.csv"}, and there is no need to change.
#' @param metaDataPattern a filename pattern for the metadata .csv file that 
#' contains spatial coords. Default value is \code{"CellCoordinates.csv"}, and 
#' there is no need to change.
#' @param coordNames a vector of two strings specify the spatial coord names. 
#' Default value is \code{c("center_x", "center_y")}, and there is no need to change.
#' 
#' @details
#' The constructor assumes the downloaded seqFISH count matrix and metadata in 
#' the same folder with the following structure:
#' seqFISH_folder/ \cr
#' · | — *_CellxGene.csv \cr
#' · | — *_CellCoordinates.csv \cr
#' 
#'
#' @return  a \code{\link{SpatialExperiment}} or a \code{\link{SingleCellExperiment}} object 
#' @export
#' 
#' @author Yixing Estella Dong
#'
#' @examples
#' # A relatively small data download can be from:
#' # https://spatialgenomics.com/data/#kidney-data
#' 
#' 
#' # A mock counts and mock metadata with spatial location generated for a 9 genes by 
#' # 13 cells object is in /extdata: 
#' 
#' seqfpath <- system.file(
#'   file.path("extdata", "seqFISH_small"),
#'   package = "SpatialExperimentIO")
#'   
#' list.files(seqfpath)
#' 
#' # One of the following depending on your output (`SPE` or `SCE`) requirement.
#' seqf_spe <- readSeqfishSXE(dirName = seqfpath)
#' seqf_sce <- readSeqfishSXE(dirName = seqfpath, returnType = "SCE")
#' 
#' 
#' @importFrom SpatialExperiment SpatialExperiment
#' @importFrom SingleCellExperiment SingleCellExperiment rowData counts colData
#' @importFrom methods as
#' @importFrom utils read.csv
readSeqfishSXE <- function(dirName = dirName, 
                           returnType = "SPE",
                           countMatPattern = "CellxGene.csv", 
                           metaDataPattern = "CellCoordinates.csv", 
                           coordNames = c("center_x", "center_y")){
  
  returnType <- match.arg(returnType, choices = c("SPE", "SCE"))
  tech <- "Seqfish"
  
  # Sanity checks
  countmat_file <- .sanityCheck(tech, filetype = "count matrix", expectfilename = "`CellxGene.csv`", dirName = dirName, filepatternvar = countMatPattern)
  metadata_file <- .sanityCheck(tech, filetype = "metadata", expectfilename = "`CellCoordinates.csv`", dirName = dirName, filepatternvar = metaDataPattern)
  
  # Read in 
  countmat <- read.csv(countmat_file)
  names(countmat)[names(countmat) == "X"] <- "cell"
  countmat <- countmat[order(countmat$cell), ]
  
  metadata <- read.csv(metadata_file)
  names(metadata)[names(metadata) == "label"] <- "cell"
  metadata <- metadata[order(metadata$cell), ]
  
  # Count matrix 
  countmat <- t(subset(countmat, select = -cell))
  
  # rowData (does not exist)
  
  # metadata
  metadata <- subset(metadata, select = -cell)
  
  if(!all(coordNames %in% colnames(metadata))){
    stop("`coordNames` not in columns of `metaDataPattern`. For seqFISH, expect c('center_x', 'center_y') in the columns of the metadata 'cell_metadata.csv'. " )
  }
  
  if(returnType == "SPE"){
    # construct 'SpatialExperiment'
    sxe <- SpatialExperiment::SpatialExperiment(
      assays = list(counts = as(countmat, "dgCMatrix")),
      # rowData = rowData,
      colData = metadata,
      spatialCoordsNames = coordNames)
  }else if(returnType == "SCE"){
    # construct 'SingleCellExperiment'
    sxe <- SingleCellExperiment::SingleCellExperiment(
      assays = list(counts = as(countmat, "dgCMatrix")),
      colData = metadata
    )
  }
  
  return(sxe)
  
}

dir <- system.file(
  file.path("extdata", "seqFISH_small"), 
  package="SpatialExperimentIO")

test_that("example data folders uniquely contains needed files", {
  expect_true("TestSetSmall_CellCoordinates.csv" %in% list.files(dir))
  expect_true("TestSetSmall_CellxGene.csv" %in% list.files(dir)) 
  
  expect_length(list.files(dir, "CellCoordinates.csv"), 1)
  expect_length(list.files(dir, "CellxGene.csv"), 1)
})

test_that("needed files contains spatial columns of interest", {
  metadata <- read.csv(file.path(dir, "TestSetSmall_CellCoordinates.csv"))
  
  expect_true(all(c("center_x", "center_y") %in% colnames(metadata))) 
  expect_true(is.numeric(metadata$center_x))
  expect_true(is.numeric(metadata$center_y))
})

test_that("data are read correctly to SpatialExperiment class", {
  x <- readSeqfishSXE(dirName = dir, 
                       returnType = "SPE",
                       countMatPattern = "CellxGene.csv", 
                       metaDataPattern = "CellCoordinates.csv", 
                       coordNames = c("center_x", "center_y"))
  
  expect_s4_class(x, "SpatialExperiment")
  expect_true(all(colnames(SpatialExperiment::spatialCoords(x)) == c("center_x", "center_y")))
  expect_false(is.null(rownames(x)))
  expect_false(is.null(colnames(x)))
  expect_true(all(dim(x) == c(9, 14)))
  expect_s4_class(SingleCellExperiment::counts(x), "dgCMatrix")
})

test_that("data are read correctly to SingleCellExperiment class", {
  x <- readSeqfishSXE(dirName = dir, 
                       returnType = "SCE",
                       countMatPattern = "CellxGene.csv", 
                       metaDataPattern = "CellCoordinates.csv", 
                       coordNames = c("center_x", "center_y"))
  
  expect_s4_class(x, "SingleCellExperiment")
  expect_true(all(c("center_x", "center_y") %in% colnames(SingleCellExperiment::colData(x))))
  expect_false(is.null(rownames(x)))
  expect_false(is.null(colnames(x)))
  expect_true(all(dim(x) == c(9, 14)))
  expect_s4_class(SingleCellExperiment::counts(x), "dgCMatrix")
})

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(cache = TRUE, autodep = TRUE, cache.lazy = FALSE)

## ----warning=FALSE, message=FALSE---------------------------------------------
suppressMessages({
  library(SpatialExperimentIO)
  library(SpatialExperiment)
})

## ----eval=FALSE---------------------------------------------------------------
# ### DO NOT RUN. Example code.
# xepath <- "/path/to/folder"
# # Xenium as SPE, or SCE by setting `returnType = "SCE"`.
# xe_spe <- readXeniumSXE(dirName = xepath)

## ----eval=FALSE---------------------------------------------------------------
# ### DO NOT RUN. Example code.
# cospath <- "/path/to/folder"
# # CosMx as SPE, or SCE by setting `returnType = "SCE"`.
# cos_spe <- readCosmxSXE(dirName = cospath)

## ----eval=FALSE---------------------------------------------------------------
# ### DO NOT RUN. Example code.
# merpath <- "/path/to/folder"
# # MERSCOPE as SPE, or SCE by setting `returnType = "SCE"`.
# mer_spe <- readMerscopeSXE(dirName = merpath)

## ----eval=FALSE---------------------------------------------------------------
# ### DO NOT RUN. Example code.
# starpath <- "/path/to/folder"
# # STARmapPLUS as SPE, or SCE by setting `returnType = "SCE"`.
# star_spe <- readStarmapplusSXE(dirName = starpath)

## ----eval=FALSE---------------------------------------------------------------
# ### DO NOT RUN. Example code.
# seqfpath <- "/path/to/folder"
# # seqFISH as SPE, or SCE by setting `returnType = "SCE"`.
# seqf_spe <- readSeqfishSXE(dirName = merpath)

## -----------------------------------------------------------------------------
xepath <- system.file(
  file.path("extdata", "Xenium_small"),
  package = "SpatialExperimentIO")

list.files(xepath)

## ----eval=FALSE---------------------------------------------------------------
# # read the count matrix .h5 file - automatically DropletUtils::read10xCounts(type = "HDF5")
# xe_spe <- readXeniumSXE(dirName = xepath,
#                         returnType = "SPE",
#                         countMatPattern = "cell_feature_matrix.h5",
#                         metaDataPattern = "cells.parquet",
#                         coordNames = c("x_centroid", "y_centroid"),
#                         addExperimentXenium = TRUE, # set to TRUE to load experiment.xenium
#                         altExps = c("NegControlProbe", "UnassignedCodeword",
#                                     "NegControlCodeword", "antisense", "BLANK"),
#                         addParquetPaths = TRUE #, # set TRUE to load all .parquet below
#                         # ... # takes arguments as below
#                         )
# xe_spe <- addParquetPathsXenium(sxe = xe_spe,
#                                 dirName = xepath,
#                                 addTx = TRUE,
#                                 txMetaNames = "transcripts",
#                                 txPattern = "transcripts.parquet",
#                                 addCellBound = TRUE,
#                                 cellBoundMetaNames = "cell_boundaries",
#                                 cellBoundPattern = "cell_boundaries.parquet",
#                                 addNucBound = TRUE,
#                                 NucBoundMetaNames = "nucleus_boundaries",
#                                 NucBoundPattern = "nucleus_boundaries.parquet")

## -----------------------------------------------------------------------------
xe_spe <- readXeniumSXE(dirName = xepath)
xe_spe

## -----------------------------------------------------------------------------
xe_spe <- readXeniumSXE(xepath,
                        altExps = c("TestGene"),
                        addParquetPaths = TRUE,
                        addTx = FALSE)
xe_spe

## ----eval=FALSE---------------------------------------------------------------
# list.files(file.path(xepath, "cell_feature_matrix"))
# # "barcodes.tsv.gz" "features.tsv.gz" "matrix.mtx.gz"

## ----eval=FALSE---------------------------------------------------------------
# # or read the count matrix folder - automatically DropletUtils::read10xCounts(type = "sparse")
# xe_spe <- readXeniumSXE(dirName = xepath,
#                         countMatPattern = "cell_feature_matrix")

## -----------------------------------------------------------------------------
xe_sce <- readXeniumSXE(dirName = xepath, returnType = "SCE")
xe_sce

## -----------------------------------------------------------------------------
cospath <- system.file(
  file.path("extdata", "CosMx_small"),
  package = "SpatialExperimentIO")

list.files(cospath)

## ----eval=FALSE---------------------------------------------------------------
# cos_spe <- readCosmxSXE(dirName = cospath,
#                         returnType = "SPE",
#                         countMatPattern = "exprMat_file.csv",
#                         metaDataPattern = "metadata_file.csv",
#                         coordNames = c("CenterX_global_px", "CenterY_global_px"),
#                         addFovPos = TRUE, # set to TRUE to add fov position columns to colData()
#                         fovPosPattern = "fov_positions_file.csv",
#                         altExps = c("NegPrb", "Negative", "SystemControl", "FalseCode"),
#                         addParquetPaths = TRUE # , # set TRUE to add all .parquet below
#                         # ... # takes arguments as below
#                         )
# cos_spe <- addParquetPathsCosmx(sxe = cos_spe,
#                                 dirName = cospath,
#                                 addTx = TRUE,
#                                 txMetaNames = "transcripts",
#                                 txPattern = "tx_file.csv",
#                                 addPolygon = TRUE,
#                                 polygonMetaNames = "polygons",
#                                 polygonPattern = "polygons.csv")

## -----------------------------------------------------------------------------
cos_spe <- readCosmxSXE(cospath,
                        addPolygon = FALSE)
cos_spe

## -----------------------------------------------------------------------------
cos_sce <- readCosmxSXE(dirName = cospath, addPolygon = FALSE, returnType = "SCE")
cos_sce

## -----------------------------------------------------------------------------
merpath <- system.file(
  file.path("extdata", "MERSCOPE_small"),
  package = "SpatialExperimentIO")

list.files(merpath)

## -----------------------------------------------------------------------------
# mer_spe <- readMerscopeSXE(dirName = merpath, 
#                            returnType = "SPE",
#                            countMatPattern = "cell_by_gene.csv", 
#                            metaDataPattern = "cell_metadata.csv", 
#                            coordNames = c("center_x", "center_y"))

mer_spe <- readMerscopeSXE(dirName = merpath)
mer_spe

## -----------------------------------------------------------------------------
mer_sce <- readMerscopeSXE(dirName = merpath, returnType = "SCE")
mer_sce

## -----------------------------------------------------------------------------
starpath <- system.file(
  file.path("extdata", "STARmapPLUS_small"),
  package = "SpatialExperimentIO")

list.files(starpath)

## -----------------------------------------------------------------------------
# readStarmapplusSXE <- function(dirName = dirName, 
#                                returnType = "SPE",
#                                countMatPattern = "raw_expression_pd.csv", 
#                                metaDataPattern = "spatial.csv", 
#                                coordNames = c("X", "Y", "Z"))

star_spe <- readStarmapplusSXE(dirName = starpath)
star_spe

## -----------------------------------------------------------------------------
star_sce <- readStarmapplusSXE(dirName = starpath, returnType = "SCE")
star_sce

## -----------------------------------------------------------------------------
seqfpath <- system.file(
  file.path("extdata", "seqFISH_small"),
  package = "SpatialExperimentIO")

list.files(seqfpath)

## -----------------------------------------------------------------------------
# seqf_spe <- readSeqfishSXE(dirName = seqfpath, 
#                            returnType = "SPE",
#                            countMatPattern = "cell_by_gene.csv", 
#                            metaDataPattern = "cell_metadata.csv", 
#                            coordNames = c("center_x", "center_y"))

seqf_spe <- readSeqfishSXE(dirName = seqfpath)
seqf_spe

## -----------------------------------------------------------------------------
seqf_sce <- readSeqfishSXE(dirName = seqfpath, returnType = "SCE")
seqf_sce

## ----tidy = TRUE--------------------------------------------------------------
sessionInfo()

#' @rdname readXeniumSXE
#' 
#' @title Load data from a 10x Geonomics Xenium experiment
#' 
#' @description
#' Creates a \code{\link{SpatialExperiment}} from the downloaded unzipped Xenium 
#' Output Bundle directory for 10x Genomics Xenium spatial gene expression data.
#'
#' @param dirName a directory path to Xenium Output Bundle download that contains 
#' files of interest.
#' @param returnType option of \code{"SPE"} or \code{"SCE"}, stands for 
#' \code{SpatialExperiment} or \code{SingleCellExperiment} object. Default value \code{"SPE"}
#' @param countMatPattern a folder directory or the h5 file pattern for the count matrix. 
#' Default value is \code{"cell_feature_matrix.h5"}, alternative value is 
#' \code{"cell_feature_matrix"} that takes a bit longer. The count matrix is 
#' read in and stored in a \code{SingleCellExperiment} object, using 
#' \code{DropletUtils::read10xCounts()}
#' @param metaDataPattern a filename pattern of the zipped .csv file that 
#' contains spatial coords. Default value is \code{"cells.csv.gz"}, and there is no 
#' need to change.
#' @param coordNames a vector of two strings specify the spatial coord names. 
#' Default value is \code{c("x_centroid", "y_centroid")}, and there is no need to change.
#' 
#' @param addExperimentXenium to add experiment.xenium parameters to \code{metadata(sxe)} or not. 
#' Default value is TRUE. 
#' @param altExps gene names contains these strings will be moved to \code{altExps(sxe)} as separate sxe-s. 
#' Default is \code{c("NegControlProbe", "UnassignedCodeword", "NegControlCodeword", "antisense", "BLANK")}. 
#' @param addParquetPaths to add parquet paths to \code{metadata(sxe)} or not. If TRUE, 
#' transcripts, cell_boundaries, and nucleus_boundaries .parquet paths will be added to `metadata()`. 
#' If, for instance, no cell_boundaries file is available, and transcript and nucleus_boundaries
#' files are available, please set this argument to TRUE and adjust `addCellBound = FALSE` 
#' in the \code{...} argument. Default is TRUE.
#' @param ... extra parameters to pass to \code{\link{addParquetPathsXenium}()}, including 
#' `addTx`, `txMetaNames`, `txPattern`, `addCellBound`, `cellBoundMetaNames`, 
#' `cellBoundPattern`, `addNucBound`, `NucBoundMetaNames`, `NucBoundPattern`.
#' 
#'
#' @details
#' The constructor assumes the downloaded unzipped Xenium Output Bundle has the 
#' following structure, with mandatory file of cells.csv.gz and either folder 
#' /cell_feature_matrix or .h5 file cell_feature_matrix.h5:
#' Xenium_unzipped \cr
#' · | — cell_feature_matrix.h5 \cr
#' · | — cell_feature_matrix \cr
#' · · | - barcodes.tsv.gz \cr
#' · · | - features.tsv.gz \cr
#' · · | - matrix.mtx.gz \cr
#' · | — cells.parquet \cr
#'
#' Optional files to add to the metadata() as a list of paths (will be converted to parquet):
#' · | — transcripts.parquet \cr
#' · | — cell_boundaries.parquet \cr
#' · | — nucleus_boundaries.parquet \cr
#' · | — experiment.xenium \cr
#' See addParquetPathsXenium()
#'
#' @return  a \code{\link{SpatialExperiment}} or a \code{\link{SingleCellExperiment}} object 
#' @export
#'
#' @author Yixing Estella Dong
#'
#' @examples
#' # A relatively small data set is the Xenium mouse brain data that can be 
#' # downloaded from 10X website.
#' 
#' # A mock .h5 and mock metadata with spatial location generated for a 4 genes by 
#' # 6 cells object is in /extdata: 
#' 
#' xepath <- system.file(
#'   file.path("extdata", "Xenium_small"),
#'   package = "SpatialExperimentIO")
#'   
#' list.files(xepath)
#' 
#' # One of the following depending on your input (.h5 or folder) and output 
#' # (`SPE` or `SCE`) requirement.
#' xe_spe <- readXeniumSXE(dirName = xepath)
#' \dontrun{
#' xe_spe <- readXeniumSXE(dirName = xepath, countMatPattern = "cell_feature_matrix")
#' }
#' xe_sce <- readXeniumSXE(dirName = xepath, returnType = "SCE")
#' 
#' xe_spe <- readXeniumSXE(dirName = xepath, addParquetPaths = TRUE)
#' xe_spe <- readXeniumSXE(dirName = xepath, addParquetPaths = TRUE, addNucBound = FALSE)
#'
#' @importFrom DropletUtils read10xCounts
#' @importFrom SpatialExperiment SpatialExperiment 
#' @importFrom S4Vectors metadata metadata<-
#' @importFrom SingleCellExperiment SingleCellExperiment rowData counts colData altExps altExps<-
#' @importFrom methods as
#' @importFrom arrow read_parquet read_json_arrow
#' 
readXeniumSXE <- function(dirName, 
                          returnType = "SPE",
                          countMatPattern = "cell_feature_matrix.h5",
                          metaDataPattern = "cells.parquet", # or cells.csv.gz 
                          coordNames = c("x_centroid", "y_centroid"), 
                          addExperimentXenium = TRUE,
                          altExps = c("NegControlProbe", "UnassignedCodeword", 
                                      "NegControlCodeword", "antisense", "BLANK"),
                          addParquetPaths = TRUE,
                          ...){

  returnType <- match.arg(returnType, choices = c("SPE", "SCE"))
  tech <- "Xenium"
  
  # Sanity checks
  countmat_file <- .sanityCheck(tech, filetype = "count matrix", expectfilename = "`cell_feature_matrix.h5`", 
                                dirName = dirName, filepatternvar = countMatPattern)
  metadata_file <- .sanityCheck(tech, filetype = "metadata", expectfilename = "`cells.parquet` or `cells.csv.gz`", 
                                dirName = dirName, filepatternvar = metaDataPattern)
  if(addExperimentXenium) expxe_file <- .sanityCheck(tech, filetype = "experiment.xenium", expectfilename = "`experiment.xenium`", 
                                                     dirName = dirName, filepatternvar = "experiment.xenium")
  
  # folder 
  if(!grepl(".h5", countMatPattern)){
    folders <- list.files(dirName, countMatPattern)[!grepl(".h5", list.files(dirName, countMatPattern))]
    countmat_file <- file.path(dirName, folders)
    
    if(length(dir.exists(countmat_file)) > 1){
      stop("More than one count matrix folder possible with the provided pattern `countMatPattern`")
    }
    
    if(!all(c("barcodes.tsv.gz", "features.tsv.gz", "matrix.mtx.gz") %in% list.files(countmat_file))){
      stop("For Xenium with count matrix directory input, expect '/cell_feature_matrix' 
           folder contains files 'barcodes.tsv.gz', 'features.tsv.gz', 'matrix.mtx.gz'")
    }
    
  }

  # Count matrix + rowData
  sce <- DropletUtils::read10xCounts(countmat_file, col.names = TRUE)
  
  # Spatial and metadata
  if(grepl(".parquet", metaDataPattern)){
    metadata <- as.data.frame(read_parquet(metadata_file)) 
  }else if(grepl(".csv.gz", metaDataPattern)){
    metadata <- read.csv(gzfile(metadata_file), header = TRUE)
  }else{
    stop("Expect `.parquet` or `.csv.gz` format for metadata. Please convert and 
         save file needed first with e.g. arrow::write_parquet() or R.utils::gzip(). ")
  }

  if(!all(coordNames %in% colnames(metadata))){
    stop("`coordNames` not in columns of `metaDataPattern`. For Xenium, expect 
         c('x_centroid', 'y_centroid') in the columns of the metadata 'cells.csv.gz'. " )
  }
  
  if(returnType == "SPE"){
    sxe <- SpatialExperiment(
      assays = list(counts = as(counts(sce), "dgCMatrix")),
      rowData = rowData(sce),
      colData = metadata,
      spatialCoordsNames = coordNames
    )
  }else if(returnType == "SCE"){
    sxe <- SingleCellExperiment(
      assays = list(counts = as(counts(sce), "dgCMatrix")),
      rowData = rowData(sce),
      colData = metadata
    )
  }
  rownames(sxe) <- rowData(sxe)$Symbol
  
  if(!is.null(altExps)){
    names(altExps) <- altExps
    idx <- lapply(altExps, grep, rownames(sxe))
    idx <- idx[vapply(idx, length, numeric(1)) > 0]
    if(length(idx)){                              
      alt <- lapply(idx, \(.) sxe[., ]) 
      altExps(sxe)[names(alt)] <- alt
      sxe <- sxe[-unlist(idx), ]
    }
  }
  
  # Experiment Xenium
  if(addExperimentXenium) metadata(sxe)$experiment.xenium <- read_json_arrow(expxe_file)
  
  # Add Parquet Paths
  if(addParquetPaths) sxe <- addParquetPathsXenium(sxe, dirName, ...)
                                                        
  return(sxe)
}

dir <- system.file(
  file.path("extdata", "CosMx_small"), 
  package="SpatialExperimentIO")

test_that("Able to add a file path for CosMx", {
  x <- readCosmxSXE(dirName = dir, addParquetPaths = FALSE)
  expect_true("fov_positions" %in% names(metadata(x)))
  
  x <- addParquetPathToMeta(x, dirName = dir,
                            metaNames = "transcripts",
                            filePattern = "tx_file.csv")
  expect_true("transcripts" %in% names(metadata(x)))
})


dir <- system.file(
  file.path("extdata", "Xenium_small"), 
  package="SpatialExperimentIO")

test_that("Able to add a file path for Xenium", {
  x <- readXeniumSXE(dirName = dir, addParquetPaths = FALSE)
  expect_true(length(metadata(x)) == 1)
  
  x <- addParquetPathToMeta(x, dirName = dir, 
                            metaNames = "transcripts",
                            filePattern = "transcripts.parquet")
  expect_true("transcripts" %in% names(metadata(x)))
  
  x <- addParquetPathToMeta(x, dirName = dir, 
                            metaNames = "cell_boundaries",
                            filePattern = "cell_boundaries.parquet")
  expect_true("cell_boundaries" %in% names(metadata(x)))
  
  x <- addParquetPathToMeta(x, dirName = dir, 
                            metaNames = "nucleus_boundaries",
                            filePattern = "nucleus_boundaries.parquet")
  expect_true("nucleus_boundaries" %in% names(metadata(x)))
})

dir <- system.file(
  file.path("extdata", "Xenium_small"), 
  package="SpatialExperimentIO")
# dir <- "~/Desktop/SpatialExperimentIO/inst/extdata/Xenium_small"
# dir <- "~/Downloads/BC_data/Xenium_rep2"
# dir <- "~/Downloads/CRC_data/Xenium"

test_that("Able to add files independently for Xenium", {
  x <- readXeniumSXE(dirName = dir, addParquetPaths = FALSE)
  expect_true(length(metadata(x)) == 1)
  
  x <- addParquetPathsXenium(x, dirName = dir)
  expect_true("transcripts" %in% names(metadata(x)))
  expect_true("cell_boundaries" %in% names(metadata(x)))
  expect_true("nucleus_boundaries" %in% names(metadata(x)))
})

dir <- system.file(
  file.path("extdata", "Xenium_small"), 
  package="SpatialExperimentIO")

test_that("example data folders uniquely contains needed files", {
  expect_true("cell_feature_matrix.h5" %in% list.files(dir))
  # expect_true("cells.csv.gz" %in% list.files(dir)) 
  expect_true("cells.parquet" %in% list.files(dir)) 
  expect_true("cell_boundaries.parquet" %in% list.files(dir))
  expect_true("nucleus_boundaries.parquet" %in% list.files(dir))
  expect_true("transcripts.parquet" %in% list.files(dir)) 
  expect_true("experiment.xenium" %in% list.files(dir)) 
  
  expect_length(list.files(dir, "cell_feature_matrix.h5"), 1)
  expect_length(list.files(dir, "cells.parquet"), 1)
  expect_length(list.files(dir, "cell_boundaries.parquet"), 1)
  expect_length(list.files(dir, "nucleus_boundaries.parquet"), 1)
  expect_length(list.files(dir, "transcripts.parquet"), 1)
  expect_length(list.files(dir, "experiment.xenium"), 1)
})

test_that("needed files contains spatial columns of interest", {
  metadata <- read.csv(gzfile(file.path(dir, "cells.csv.gz")), header = TRUE)
  
  expect_true(all(c("x_centroid", "y_centroid") %in% colnames(metadata))) 
  expect_true(is.numeric(metadata$x_centroid))
  expect_true(is.numeric(metadata$y_centroid))
})

test_that("data are read correctly to SpatialExperiment class", {
  x <- readXeniumSXE(dir, 
                     returnType = "SPE",
                     countMatPattern = "cell_feature_matrix.h5",
                     metaDataPattern = "cells.parquet", # or cells.csv.gz 
                     coordNames = c("x_centroid", "y_centroid"), 
                     addExperimentXenium = TRUE,
                     altExps = NULL,
                     addParquetPaths = FALSE)
  
  expect_s4_class(x, "SpatialExperiment")
  expect_true(all(colnames(SpatialExperiment::spatialCoords(x)) == c("x_centroid", "y_centroid")))
  expect_false(is.null(rownames(x)))
  expect_false(is.null(colnames(x)))
  expect_true(all(dim(x) == c(4, 6)))
  expect_s4_class(SingleCellExperiment::counts(x), "dgCMatrix")
  expect_true("experiment.xenium" %in% names(metadata(x)))
})

test_that("data are read correctly to SingleCellExperiment class", {
  x <- readXeniumSXE(dir, 
                     returnType = "SCE",
                     countMatPattern = "cell_feature_matrix.h5",
                     metaDataPattern = "cells.csv.gz", # back compatibility 
                     coordNames = c("x_centroid", "y_centroid"), 
                     addExperimentXenium = FALSE,
                     altExps = NULL,
                     addParquetPaths = TRUE,
                     addTx = FALSE)
  
  expect_s4_class(x, "SingleCellExperiment")
  expect_true(all(c("x_centroid", "y_centroid") %in% colnames(SingleCellExperiment::colData(x))))
  expect_false(is.null(rownames(x)))
  expect_false(is.null(colnames(x)))
  expect_true(all(dim(x) == c(4, 6)))
  expect_s4_class(SingleCellExperiment::counts(x), "dgCMatrix")
  expect_false("transcripts" %in% names(metadata(x)))
  expect_true("cell_boundaries" %in% names(metadata(x)))
  expect_true("nucleus_boundaries" %in% names(metadata(x)))
})

## Test altExp
# test_that("data are read correctly to SingleCellExperiment class", {
#   x <- readXeniumSXE(dir, 
#                      returnType = "SCE",
#                      countMatPattern = "cell_feature_matrix.h5",
#                      metaDataPattern = "cells.csv.gz", # back compatibility 
#                      coordNames = c("x_centroid", "y_centroid"), 
#                      addExperimentXenium = FALSE,
#                      altExps = c(negprobe="^NegControlProbe", antisense = "^antisense", negcode="^NegControlCodeword", blank = "^BLANK"),
#                      addParquetPaths = TRUE,
#                      addTx = FALSE)
#   
#   expect_s4_class(x, "SingleCellExperiment")
#   expect_true(all(c("negprobe", "antisense", "negcode", "blank") %in% altExpNames(x)))
# })

#' Sanity check if one and only file with the specified name pattern exists in 
#' the data download directory, and return the file path to .csv
#' Used for count matrix and metadata only, as they require unique. 
#'
#' @param tech Name of technology. Defined at the beginning of the function. e.g. "CosMx"
#' @param filetype File type to do sanity check. e.g. "metadata"
#' @param expectfilename Expected file pattern name for this file type. e.g. "metadata_file.csv"
#' @param dirName Directory to the data download. 
#' @param filepatternvar The file pattern variable. e.g. "metaDataPattern"
#'
#' @author Yixing Estella Dong
#' 
#' @return a path to a unique file of count matrix or colData.
#'
#' @examples 
#' \dontrun{
#' dir <- system.file(file.path("extdata", "CosMx_small"),
#'                    package = "SpatialExperimentIO")
#' countmat_file <- SpatialExperimentIO:::.sanityCheck(tech = "CosMx", 
#'                               filetype = "count matrix",
#'                               expectfilename = "`exprMat_file.csv`",
#'                               dirName = dir,
#'                               filepatternvar = "exprMat_file.csv")
#'}
.sanityCheck <- function(tech, filetype, expectfilename, dirName, filepatternvar){
  if(!any(file.exists(file.path(dirName, list.files(dirName, filepatternvar))))){
    stop(paste(tech, filetype , "file does not exist in the directory. Expect", 
               expectfilename, "in", "`dirName`"))
  }
  
  path_to_file <- file.path(dirName, list.files(dirName, filepatternvar))
  if(length(path_to_file) > 1){
    stop(paste("More than one", filetype, "file possible with the provided pattern"))
  }
  
  return(path_to_file)
}



#' If transcripts or polygon is expected to be loaded, write a parquet file to 
#' the current data download (if not already), and return the file path to .parquet
#'
#' @param dirName current directory of data download
#' @param filepath path to transcripts or polygons csv
#'
#' @author Yixing Estella Dong
#'
#' @return a path to .parquet
#' @export 
#'
#' @examples 
#' dir <- system.file(file.path("extdata", "CosMx_small"),
#'                    package = "SpatialExperimentIO")
#' tx_csv_path <- file.path(dir, "lung_p9s1_tx_file.csv")
#' tx_parquet_path <- csvToParquetPaths(dirName, filepath = tx_csv_path)
#' 
#' @importFrom data.table fread
#' @importFrom arrow write_parquet
#' 
csvToParquetPaths <- function(dirName, filepath = "tx_csv_path"){
  parquet_path <- paste0(gsub(".csv", "", filepath), ".parquet")
  if(!file.exists(parquet_path)) write_parquet(as.data.frame(fread(filepath)), parquet_path)

  return(parquet_path)
}



#' Add parquet paths to metadata for transcripts, polygon, or cell/nucleus boundaries.
#'
#' @param sxe a SPE or SCE object to add parquet to `metadata(sxe)`.
#' @param dirName the directory that stores the transcripts/polygon/cell_boundaries 
#' .csv or .parquet files.
#' @param metaNames  a vector of names to `metadata(sxe)[[]]`. The length must
#' match number of files detected with filePattern provided. 
#' \code{e.g. c("transcripts", "transcripts1.csv")}.
#' @param filePattern a vector of file patterns to search in the current directory. 
#' e.g. \code{c("tx_file.csv", "tx_file1.csv")}.
#'
#' @return a SPE or SCE object with parquet paths added to metadata
#' @export 
#'
#' @examples
#' dir <- system.file(file.path("extdata", "CosMx_small"),
#'                    package = "SpatialExperimentIO")
#' sxe <- readCosmxSXE(dir, addParquetPaths = FALSE)
#' sxe <- addParquetPathToMeta(sxe,
#'                             dirName = dir,
#'                             metaNames = "transcripts",
#'                             filePattern = "tx_file.parquet")
#' 
#' @importFrom purrr walk2
#' @importFrom S4Vectors metadata metadata<-
#' 
addParquetPathToMeta <- function(sxe, 
                                 dirName = dirName,
                                 metaNames = "transcripts",
                                 filePattern = "tx_file.csv"){
  if(!all(grepl(".csv|.parquet", filePattern))){
    stop(paste0("Require each ", filePattern, " in `filePattern` has a '.csv' 
                or '.parquet' file extension."))
  }
  
  fileswpat <- unlist(lapply(filePattern, list.files, path = dirName))
  
  if(length(metaNames) != length(fileswpat)){
    stop(paste0("Number of metadata slot names: ", metaNames, 
                " in `metaNames` and number of detect files with ", 
                filePattern, " in `filePattern` have different lengths"))
  }
  
  if(length(fileswpat) == 0){
    stop(paste0("File with ", filePattern, 
                " in `filePattern` does not exist in the directory."))
  }else{
    if(all(grepl(".csv", fileswpat))){           # all csv, no parquet
      tx_files <- file.path(dirName, fileswpat)
      parquet_paths <- lapply(tx_files, csvToParquetPaths, dirName = dirName)
    }else if(all(grepl(".parquet", fileswpat))){ # only parquet
      parquet_paths <- file.path(dirName, fileswpat[grepl(".parquet", fileswpat)])
    }else{                                       # a mix of parquet & csv
      tx_files <- file.path(dirName, fileswpat[grepl(".csv", fileswpat)])
      parquet_paths_csv <- lapply(tx_files, csvToParquetPaths, dirName = dirName)
      
      parquet_paths <- file.path(dirName, fileswpat[grepl(".parquet", fileswpat)])
      parquet_paths <- append(parquet_paths_csv, parquet_paths)
    }
  }
  
  parquet_paths <- unlist(parquet_paths)
  
  walk2(metaNames, parquet_paths, function(name, path) {
    metadata(sxe)[[name]] <<- path
  })
  
  return(sxe)
}

dir <- system.file(file.path("extdata", "CosMx_small"),
                   package = "SpatialExperimentIO")
tx_csv_path <- file.path(dir, "lung_p9s1_tx_file.csv")

test_that("Able to convert .csv to .parquet for CosMx", {
  tx_parquet_path <- csvToParquetPaths(dir, filepath = tx_csv_path)
  
  expect_true(file.exists(tx_parquet_path))
})

################################################################################
# Script to create a small count matrix and a small coordinate files 
# from the raw download of the Merscope human ovarian cancer
# patient 2 slice 1.
# Yixing Dong, updated Aug 2024
################################################################################

# references:
# Merscope `_cell_by_gene.csv` and `_cell_metadata.csv` file were downloaded from
# \url{https://console.cloud.google.com/storage/browser/vz-ffpe-showcase/HumanOvarianCancerPatient2Slice1;tab=objects?prefix=&forceOnObjectsSortingFiltering=false}

# in this script we subset the large raw necessary files into small ones.


# -------------
# Download data
# -------------

# Put the downloaded unzipped file into a folder. Make sure that two mandatory 
# files do exist. 

mer_ova_p1s2_path <- here::here("raw_data/mer_patient1slice2")
mer_folder <- list.files(mer_ova_p1s2_path, pattern = ".csv")
mer_folder


# -------------
# Read in raw data
# -------------

counts <- read.csv(file.path(mer_ova_p1s2_path, "OvarianP2S1_cell_by_gene.csv")) # 91992   982
meta <- read.csv(file.path(mer_ova_p1s2_path, "OvarianP2S1_cell_metadata.csv"))  # 91972    20


# -------------
# Downsize to 10 genes and 9 cells 
# -------------

library(dplyr)
meta_test <- meta[1:9, ] %>%
  select("X", "fov", "volume", "center_x", "center_y")

counts_test <- counts %>%
  mutate(X = cell) %>%
  right_join(meta_test[, c("X", "fov")], by = "X") %>%
  select(-c(X, fov)) 

counts_test <- counts_test[1:10, ]


# -------------
# Save the small data 
# -------------

mer_ovarian_p1s2_demo_path <- "~/Desktop/SpatialExperimentIO/inst/extdata/MERSCOPE_small"
write.csv(counts_test, file.path(mer_ovarian_p1s2_demo_path, "ovarian_p1s2_cell_by_gene.csv"), row.names = FALSE)
write.csv(meta_test, file.path(mer_ovarian_p1s2_demo_path, "ovarian_p1s2_cell_metadata.csv"), row.names = FALSE)


# -------------
# Sanity check
# -------------

# install necessary packages

devtools::install_github("estellad/SpatialExperimentIO")
remotes::install_github("lmweber/ggspavis")

# load packages

library(SpatialExperimentIO)
library(ggspavis)

# read the small data as SPE object, and plot it. 

spe <- readMerscopeSXE(mer_ovarian_p1s2_demo_path, return_type = "SPE")
plotSpots(spe, annotate = "volume", in_tissue = NULL)

#' @rdname readCosmxSXE
#' 
#' @title Load data from a Nanostring CosMx experiment
#' 
#' @description
#' Creates a \code{\link{SpatialExperiment}} from the downloaded unzipped CosMx  
#' directory for Nanostring CosMx spatial gene expression data.
#'
#' @param dirName a directory path to CosMx download that contains files of interest.
#' @param returnType option of \code{"SPE"} or \code{"SCE"}, stands for 
#' \code{SpatialExperiment} or \code{SingleCellExperiment} object. Default value \code{"SPE"}
#' @param countMatPattern a filename pattern for the count matrix. Default value is 
#' \code{"exprMat_file.csv"}, and there is no need to change.
#' @param metaDataPattern a filename pattern for the metadata .csv file that 
#' contains spatial coords. Default value is \code{"metadata_file.csv"}, and 
#' there is no need to change.
#' @param coordNames a vector of two strings specify the spatial coord names. 
#' Default value is \code{c("CenterX_global_px", "CenterY_global_px")}, and 
#' there is no need to change.
#' @param addFovPos to read in fov_position_list.csv and add the data frame to 
#' \code{metadata(sxe)$fov_positions} or not. Default is TRUE.
#' @param fovPosPattern .csv pattern of fov_position_list.csv files in the raw download. 
#' Default value is \code{"fov_positions_file.csv"}.
#' @param altExps gene names contains these strings will be moved to \code{altExps(sxe)} 
#' as separate sxe-s. Default is \code{c("NegPrb", "Negative", "SystemControl", "FalseCode")}. 
#' @param addParquetPaths to add parquet paths to \code{metadata(sxe)} or not. If TRUE, 
#' transcripts and polygon .csv files will be converted to .parquet, and the paths 
#' will be added. If, for instance, no polygon file is available, and only transcript 
#' file is available, please set this argument to TRUE and adjust `addPolygon = FALSE` 
#' in the \code{...} argument. Default is TRUE.
#' @param ... extra parameters to pass to \code{\link{addParquetPathsCosmx}()}, including 
#' `addTx`, `txMetaNames`, `txPattern`, `addPolygon`, `polygonMetaNames`,
#' `polygonPattern`.
#' 
#' @details
#' The constructor assumes the downloaded unzipped CosMx folder has the following
#' structure, with two mandatory files:
#' CosMx_unzipped/optional_default_folder/ \cr
#' · | — *_exprMat_file.csv \cr
#' · | — *_metadata_file.csv \cr
#' 
#' Optional files to add to the metadata() as a list of paths (will be converted to parquet):
#' · | — *_fov_positions_file.csv \cr
#' · | — *_tx_file.csv \cr
#' · | — *_polygons.csv \cr
#' If no optional files, need to set `addFovPos = FALSE` and `addParquetPaths = FALSE`.
#' If only one of `*_tx_file.csv` or `*_polygons.csv` exists, set `addParquetPaths = TRUE` but 
#' set the not available `addTx` or `addPolygon` to `FALSE`. 
#' See \code{\link{addParquetPathsCosmx}()}
#'
#' @return  a \code{\link{SpatialExperiment}} or a \code{\link{SingleCellExperiment}} object 
#' @export
#' 
#' @author Yixing Estella Dong
#'
#' @examples
#' # A relatively small data download can be from:
#' # https://nanostring.com/resources/smi-ffpe-dataset-lung9-rep1-data/
#' 
#' 
#' # A mock counts and mock metadata with spatial location generated for a 8 genes by 
#' # 9 cells object is in /extdata: 
#' 
#' cospath <- system.file(
#'   file.path("extdata", "CosMx_small"),
#'   package = "SpatialExperimentIO")
#'   
#' list.files(cospath)
#' 
#' # One of the following depending on your output (`SPE` or `SCE`) requirement.
#' cos_spe <- readCosmxSXE(dirName = cospath, addPolygon = FALSE)
#' cos_sce <- readCosmxSXE(dirName = cospath, returnType = "SCE", addPolygon = FALSE)
#' cos_spe <- readCosmxSXE(dirName = cospath, addParquetPaths = FALSE)
#' 
#' 
#' @importFrom SpatialExperiment SpatialExperiment 
#' @importFrom S4Vectors metadata metadata<-
#' @importFrom SingleCellExperiment SingleCellExperiment rowData counts colData altExps altExps<-
#' @importFrom methods as
#' @importFrom data.table fread
#' @importFrom arrow write_parquet
#' 
readCosmxSXE <- function(dirName = dirName, 
                         returnType = "SPE",
                         countMatPattern = "exprMat_file.csv", 
                         metaDataPattern = "metadata_file.csv", 
                         coordNames = c("CenterX_global_px", "CenterY_global_px"),
                         addFovPos = TRUE,
                         fovPosPattern = "fov_positions_file.csv",
                         altExps = c("NegPrb", "Negative", "SystemControl", "FalseCode"),
                         addParquetPaths = TRUE,
                         ...){
  
  returnType <- match.arg(returnType, choices = c("SPE", "SCE"))
  tech <- "CosMx"
  
  # Sanity checks
  countmat_file <- .sanityCheck(tech, filetype = "count matrix", expectfilename = "`exprMat_file.csv`", 
                                dirName = dirName, filepatternvar = countMatPattern)
  metadata_file <- .sanityCheck(tech, filetype = "metadata", expectfilename = "`metadata_file.csv`", 
                                dirName = dirName, filepatternvar = metaDataPattern)
  if(addFovPos) fov_pos_file <- .sanityCheck(tech, filetype = "fov position", expectfilename = "`fov_positions_file.csv`", 
                                              dirName = dirName, filepatternvar = fovPosPattern)
  
  # Read in 
  countmat <- as.data.frame(fread(countmat_file))
  metadata <- as.data.frame(fread(metadata_file))
  
  overlap_cols <- intersect(colnames(countmat), colnames(metadata))
  
  # Count matrix   
  counts_ <- merge(countmat, metadata[, overlap_cols])
  counts_ <- counts_[, !(colnames(counts_) %in% overlap_cols)]
  counts_ <- t(counts_)
  
  # rowData (does not exist)
  
  # metadata
  metadata <- merge(metadata, countmat[, overlap_cols])

  if(!all(coordNames %in% colnames(metadata))){
    stop("`coordNames` not in columns of `metaDataPattern`. For CosMx, expect 
         c('CenterX_global_px', 'CenterY_global_px') in the columns of the metadata 'metadata_file.csv'. " )
  }
  
  colnames(counts_) <- rownames(metadata) <- seq_len(ncol(counts_))
  
  if(returnType == "SPE"){
    sxe <- SpatialExperiment(
      assays = list(counts = as(counts_, "dgCMatrix")),
      # rowData = rowData,
      colData = metadata,
      spatialCoordsNames = coordNames)
    #altExps=alt)
  }else if(returnType == "SCE"){
    sxe <- SingleCellExperiment(
      assays = list(counts = as(counts_, "dgCMatrix")),
      colData = metadata
      #altExps=alt
    )
  }
  
  if(!is.null(altExps)){
    names(altExps) <- altExps
    idx <- lapply(altExps, grep, rownames(sxe))     # get features matching input pattern(s)
    idx <- idx[vapply(idx, length, numeric(1)) > 0] # drops elements without match
    if(length(idx)){                                # skip if there aren't any matches
      alt <- lapply(idx, \(.) sxe[., ])
      altExps(sxe)[names(alt)] <- alt
      sxe <- sxe[-unlist(idx), ]
    }
  }
  
  # Add Parquet Paths
  if(addParquetPaths) sxe <- addParquetPathsCosmx(sxe, dirName, ...)
  
  # Read in and add FovPos to metadata()
  if(addFovPos){
    fovpos <- as.data.frame(fread(fov_pos_file))
    metadata(sxe)$fov_positions <- fovpos
  }
  
  return(sxe)
}

dir <- system.file(
  file.path("extdata", "CosMx_small"), 
  package="SpatialExperimentIO")

# dir <- "~/Desktop/SpatialExperimentIO/inst/extdata/CosMx_small"
# dir <- "~/Downloads/Pancreas_CosMx_WTX"
# dir <- "~/Downloads/HumanFC"
# dir <- "~/Downloads/Lung9_Rep1"

test_that("Able to add files independently for CosMx", {
  x <- readCosmxSXE(dirName = dir, addParquetPaths = FALSE)
  expect_true("fov_positions" %in% names(metadata(x)))
  
  x <- addParquetPathsCosmx(x, dirName = dir, addPolygon = FALSE)
  expect_true("transcripts" %in% names(metadata(x)))
})

dir <- system.file(
  file.path("extdata", "CosMx_small"), 
  package="SpatialExperimentIO")

test_that("example data folders uniquely contains needed files", {
  expect_true("lung_p9s1_exprMat_file.csv" %in% list.files(dir))
  expect_true("lung_p9s1_metadata_file.csv" %in% list.files(dir)) 
  expect_true("lung_p9s1_fov_positions_file.csv" %in% list.files(dir))
  expect_true("lung_p9s1_tx_file.csv" %in% list.files(dir))
  
  # parquet
  expect_true("lung_p9s1_tx_file.parquet" %in% list.files(dir))
  
  expect_length(list.files(dir, "exprMat_file.csv"), 1)
  expect_length(list.files(dir, "metadata_file.csv"), 1)
  expect_length(list.files(dir, "fov_positions_file.csv"), 1)
  expect_length(list.files(dir, "tx_file.csv"), 1)
  
  # parquet
  expect_length(list.files(dir, "lung_p9s1_tx_file.parquet"), 1)
})

test_that("needed files contains spatial columns of interest", {
  metadata <- read.csv(file.path(dir, "lung_p9s1_metadata_file.csv"))
  
  expect_true(all(c("CenterX_global_px", "CenterY_global_px") %in% colnames(metadata))) 
  expect_true(is.numeric(metadata$CenterX_global_px))
  expect_true(is.numeric(metadata$CenterY_global_px))
})

test_that("needed fov position files contains columns of interest, with fov position in colData", {
  metadata <- read.csv(file.path(dir, "lung_p9s1_fov_positions_file.csv"))
  
  expect_true(all(c("fov", "x_global_px", "y_global_px") %in% colnames(metadata))) 
  expect_true(is.numeric(metadata$fov))
  expect_true(is.numeric(metadata$x_global_px))
  expect_true(is.numeric(metadata$y_global_px))
})

test_that("data are read correctly to SpatialExperiment class", {
  x <- readCosmxSXE(dirName = dir, 
                    returnType = "SPE",
                    countMatPattern = "exprMat_file.csv", 
                    metaDataPattern = "metadata_file.csv", 
                    coordNames = c("CenterX_global_px", "CenterY_global_px"),
                    addFovPos = TRUE,
                    fovPosPattern = "fov_positions_file.csv",
                    altExps = NULL,
                    addParquetPaths = FALSE)
  
  expect_s4_class(x, "SpatialExperiment")
  expect_true(all(colnames(SpatialExperiment::spatialCoords(x)) == c("CenterX_global_px", "CenterY_global_px")))
  expect_false(is.null(rownames(x)))
  expect_false(is.null(colnames(x)))
  expect_true(all(dim(x) == c(8, 9)))
  expect_s4_class(SingleCellExperiment::counts(x), "dgCMatrix")
  expect_true(is.data.frame(S4Vectors::metadata(x)$fov_positions)) 
})

test_that("data are read correctly to SingleCellExperiment class, no fov position in colData", {
  x <- readCosmxSXE(dirName = dir, 
                    returnType = "SCE",
                    countMatPattern = "exprMat_file.csv", 
                    metaDataPattern = "metadata_file.csv", 
                    coordNames = c("CenterX_global_px", "CenterY_global_px"),
                    addFovPos = FALSE,
                    fovPosPattern = "fov_positions_file.csv",
                    altExps = NULL,
                    addParquetPaths = FALSE)
  
  expect_s4_class(x, "SingleCellExperiment")
  expect_true(all(c("CenterX_global_px", "CenterY_global_px") %in% colnames(SingleCellExperiment::colData(x))))
  expect_false(is.null(rownames(x)))
  expect_false(is.null(colnames(x)))
  expect_true(all(dim(x) == c(8, 9)))
  expect_s4_class(SingleCellExperiment::counts(x), "dgCMatrix")
  expect_true(is.null(S4Vectors::metadata(x)$fov_positions)) 
})

test_that("data can be read in, even no polygon file, had addPolygon = FALSE, and transcripts read in to metadata(()", {
  x <- readCosmxSXE(dirName = dir, 
                    returnType = "SPE",
                    countMatPattern = "exprMat_file.csv", 
                    metaDataPattern = "metadata_file.csv", 
                    coordNames = c("CenterX_global_px", "CenterY_global_px"),
                    addFovPos = TRUE,
                    fovPosPattern = "fov_positions_file.csv",
                    altExps = NULL,
                    addParquetPaths = TRUE,
                    addPolygon = FALSE)
  expect_true(S4Vectors::metadata(x)$transcripts == file.path(dir, "lung_p9s1_tx_file.parquet"))
  expect_true(is.null(S4Vectors::metadata(x)$polygons))
})

test_that("data can be read in, directly read parquet of transcripts", {
  x <- readCosmxSXE(dirName = dir, 
                    returnType = "SPE",
                    countMatPattern = "exprMat_file.csv", 
                    metaDataPattern = "metadata_file.csv", 
                    coordNames = c("CenterX_global_px", "CenterY_global_px"),
                    addFovPos = TRUE,
                    fovPosPattern = "fov_positions_file.csv",
                    altExps = NULL,
                    addParquetPaths = TRUE,
                    addPolygon = FALSE,
                    txPattern = "tx_file.parquet")
  expect_true(metadata(x)$transcripts == file.path(dir, "lung_p9s1_tx_file.parquet"))
  # expect_true(metadata(x)$transcripts == file.path(dir, "tx_file.parquet"))
})

test_that("data can be read in, directly read parquet of transcripts multiple", {
  x <- readCosmxSXE(dirName = dir, 
                    returnType = "SPE",
                    countMatPattern = "exprMat_file.csv", 
                    metaDataPattern = "metadata_file.csv", 
                    coordNames = c("CenterX_global_px", "CenterY_global_px"),
                    addFovPos = TRUE,
                    fovPosPattern = "fov_positions_file.csv",
                    altExps = NULL,
                    addParquetPaths = TRUE,
                    addPolygon = FALSE,
                    txMetaNames = c("transcripts", "transcripts2"),
                    txPattern = c("tx_file.csv", "tx_file.parquet"))
  expect_true(metadata(x)$transcripts == file.path(dir, "lung_p9s1_tx_file.parquet"))
  expect_true(metadata(x)$transcripts2 == file.path(dir, "lung_p9s1_tx_file.parquet"))
})

## Test altExp
# test_that("data can be read in, directly read parquet of transcripts", {
#   x <- readCosmxSXE(dirName = dir, 
#                     returnType = "SPE",
#                     countMatPattern = "exprMat_file.csv", 
#                     metaDataPattern = "metadata_file.csv", 
#                     coordNames = c("CenterX_global_px", "CenterY_global_px"),
#                     addFovPos = TRUE,
#                     fovPosPattern = "fov_positions_file.csv",
#                     altExps = c(negprobe="^Neg", falsecode="^Sys"),
#                     addParquetPaths = FALSE)
#   
#   expect_true(all(c("negprobe", "falsecode") %in% altExpNames(x)))
# })

#' @rdname readStarmapplusSXE
#' 
#' @title Load data from a STARmap PLUS experiment
#' 
#' @description
#' Creates a \code{\link{SpatialExperiment}} from the downloaded STARmap PLUS count
#' matrix.csv and metadata.csv
#'
#' @param dirName a directory path to STARmap PLUS download that contains files of interest.
#' @param returnType option of \code{"SPE"} or \code{"SCE"}, stands for 
#' \code{SpatialExperiment} or \code{SingleCellExperiment} object. Default value \code{"SPE"}
#' @param countMatPattern a filename pattern for the count matrix. Default value is 
#' \code{"raw_expression_pd.csv"}, and there is no need to change.
#' @param metaDataPattern a filename pattern for the metadata .csv file that 
#' contains spatial coords. Default value is \code{"spatial.csv"}, and 
#' there is no need to change.
#' @param coordNames a vector of three strings specify the spatial coord names. 
#' Default value is \code{c("X", "Y", "Z")}, and there is no need to change.
#' 
#' @details
#' The constructor assumes the downloaded unzipped STARmap PLUS folder has the following
#' structure, with two mandatory files:
#' STARmap_PLUS_download/ \cr
#' · | — *raw_expression_pd.csv \cr
#' · | — *spatial.csv \cr
#' 
#'
#' @return  a \code{\link{SpatialExperiment}} or a \code{\link{SingleCellExperiment}} object 
#' @export
#' 
#' @author Yixing Estella Dong
#'
#' @examples
#' # A relatively small data download can be from:
#' # https://zenodo.org/records/8327576
#' 
#' 
#' # A mock counts and mock metadata with spatial location generated for a 8 genes by 
#' # 9 cells object is in /extdata: 
#' 
#' starpath <- system.file(
#'   file.path("extdata", "STARmapPLUS_small"),
#'   package = "SpatialExperimentIO")
#' 
#' list.files(starpath)
#' 
#' # One of the following depending on your output (`SPE` or `SCE`) requirement.
#' star_spe <- readStarmapplusSXE(dirName = starpath)
#' star_sce <- readStarmapplusSXE(dirName = starpath, returnType = "SCE")
#' 
#' 
#' @importFrom SpatialExperiment SpatialExperiment
#' @importFrom SingleCellExperiment SingleCellExperiment rowData counts colData
#' @importFrom methods as
#' @importFrom utils read.csv
readStarmapplusSXE <- function(dirName = dirName, 
                               returnType = "SPE",
                               countMatPattern = "raw_expression_pd.csv", 
                               metaDataPattern = "spatial.csv", 
                               coordNames = c("X", "Y", "Z")){
  
  returnType <- match.arg(returnType, choices = c("SPE", "SCE"))
  tech <- "Starmapplus"
  
  # Sanity checks
  countmat_file <- .sanityCheck(tech, filetype = "count matrix", expectfilename = "`raw_expression_pd.csv`", dirName = dirName, filepatternvar = countMatPattern)
  metadata_file <- .sanityCheck(tech, filetype = "metadata", expectfilename = "`spatial.csv`", dirName = dirName, filepatternvar = metaDataPattern)
  
  # Read in 
  countmat <- read.csv(countmat_file)
  metadata <- read.csv(metadata_file)
  
  # Count matrix
  rownames(countmat) <- countmat$GENE
  countmat <- subset(countmat, select = -GENE)  
  countmat <- as.matrix(countmat)

  # rowData (does not exist)
  
  # metadata
  rownames(metadata) <- metadata$NAME
  metadata <- metadata[rownames(metadata) != "TYPE", ]
  metadata$X <- as.numeric(metadata$X)
  metadata$Y <- as.numeric(metadata$Y)
  metadata$Z <- as.numeric(metadata$Z)
  
  if(!all(coordNames %in% colnames(metadata))){
    stop("`coordNames` not in columns of `metaDataPattern`. For STARmap PLUS, expect c('X', 'Y', 'Z') in the columns of the metadata 'spatial.csv'. " )
  }
  
  if(returnType == "SPE"){
    sxe <- SpatialExperiment::SpatialExperiment(
      assays = list(counts = as(countmat, "dgCMatrix")),
      # rowData = rowData,
      colData = metadata,
      spatialCoordsNames = coordNames)
  }else if(returnType == "SCE"){
    # construct 'SingleCellExperiment'
    sxe <- SingleCellExperiment::SingleCellExperiment(
      assays = list(counts = as(countmat, "dgCMatrix")),
      colData = metadata
    )
  }
  
  return(sxe)
}

dir <- system.file(
  file.path("extdata", "STARmapPLUS_small"), 
  package="SpatialExperimentIO")

test_that("example data folders uniquely contains needed files", {
  expect_true("mockraw_expression_pd.csv" %in% list.files(dir))
  expect_true("mock_spatial.csv" %in% list.files(dir)) 
  
  expect_length(list.files(dir, "spatial.csv"), 1)
  expect_length(list.files(dir, "raw_expression_pd.csv"), 1)
})

test_that("needed files contains spatial columns of interest", {
  metadata <- read.csv(file.path(dir, "mock_spatial.csv"))
  
  expect_true(all(c("X", "Y", "Z") %in% colnames(metadata))) 
})

test_that("data are read correctly to SpatialExperiment class", {
  x <- readStarmapplusSXE(dirName = dir, 
                          returnType = "SPE",
                          countMatPattern = "raw_expression_pd.csv", 
                          metaDataPattern = "spatial.csv", 
                          coordNames = c("X", "Y", "Z"))
  
  expect_s4_class(x, "SpatialExperiment")
  expect_true(all(colnames(SpatialExperiment::spatialCoords(x)) == c("X", "Y", "Z")))
  expect_false(is.null(rownames(x)))
  expect_false(is.null(colnames(x)))
  expect_true(all(dim(x) == c(8, 9)))
  expect_s4_class(SingleCellExperiment::counts(x), "dgCMatrix")
})

test_that("data are read correctly to SingleCellExperiment class", {
  x <- readStarmapplusSXE(dirName = dir, 
                          returnType = "SCE",
                          countMatPattern = "raw_expression_pd.csv", 
                          metaDataPattern = "spatial.csv", 
                          coordNames = c("X", "Y", "Z"))
  
  expect_s4_class(x, "SingleCellExperiment")
  expect_true(all(c("X", "Y", "Z") %in% colnames(SingleCellExperiment::colData(x))))
  expect_false(is.null(rownames(x)))
  expect_false(is.null(colnames(x)))
  expect_true(all(dim(x) == c(8, 9)))
  expect_s4_class(SingleCellExperiment::counts(x), "dgCMatrix")
})

# ---------------------------
# Create metadata spreadsheet
# ---------------------------

# metadata for all datasets

df_all <- data.frame(
  Genome = NA, 
  SourceType = "FASTQ", 
  SourceVersion = NA, 
  Coordinate_1_based = NA, 
  DataProvider = NA, 
  Maintainer = "Yixing E. Dong <estelladong729@gmail.com>", 
  stringsAsFactors = FALSE
)


# metadata for individual datasets
df_Xenium_small <- cbind(
  df_all, 
  Title = "Xenium_small", 
  Description = paste0(
    "10x Genomics Xenium mock .h5 count matrix file and cells.csv.gz file ", 
    "downsized from the human breast cancer  replicate 1 in ",
    "Janesick et al. (2023)."), 
  SourceUrl = "https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSM7780153", 
  Species = "Homo sapiens", 
  TaxonomyId = "9606", 
  BiocVersion = "3.19", 
  stringsAsFactors = FALSE
)


df_CosMx_small <- cbind(
  df_all, 
  Title = "CosMx_small", 
  Description =  paste0(
    "NanoString CosMx mock .csv count matrix file and .csv coordinates file ", 
    "downsized from the human NSCLC data (patient 9, slice 1). This dataset ", 
    "was previously released by NanoString on their website."), 
  SourceUrl = "https://nanostring.com/resources/smi-ffpe-dataset-lung9-rep1-data/", 
  Species = "Homo sapiens", 
  TaxonomyId = "9606", 
  BiocVersion = "3.19", 
  stringsAsFactors = FALSE
)


df_MERSCOPE_small <- cbind(
  df_all, 
  Title = "MERSCOPE_small", 
  Description =  paste0(
    "Vizgen MERSCOPE mock .csv count matrix file and .csv coordinates file ", 
    "downsized from the human ovarian (patient 2, sample 1). This dataset was ", 
    "previously released by Vizgen on their website."), 
  SourceUrl = "https://console.cloud.google.com/storage/browser/vz-ffpe-showcase/HumanOvarianCancerPatient2Slice1;tab=objects?prefix=&forceOnObjectsSortingFiltering=false", 
  Species = "Homo sapiens", 
  TaxonomyId = "9606", 
  BiocVersion = "3.19", 
  stringsAsFactors = FALSE
)


df_STARmapPLUS_small <- cbind(
  df_all, 
  Title = "STARmapPLUS_small", 
  Description =  paste0(
    "STARmap PLUS mock .csv count matrix file and .csv coordinates file ", 
    "downsized from the mouse brain (well 05), including annotations for ", 
    "cell type and tissue regions by Shi et al. (2023). "), 
  SourceUrl = "https://zenodo.org/records/8327576", 
  Species = "Mus musculus", 
  TaxonomyId = "10090", 
  BiocVersion = "3.19", 
  stringsAsFactors = FALSE
)


df_seqFISH_small <- cbind(
  df_all, 
  Title = "seqFISH_small", 
  Description = paste0(
    "Spatial Genomics seqFISH human unknown dataset obtained from Github", 
    " issue #3 by Github user methornton. "), 
  SourceUrl = "https://github.com/estellad/SpatialExperimentIO/issues/3/", 
  Species = "Homo sapiens", 
  TaxonomyId = "9606", 
  BiocVersion = "3.19", 
  stringsAsFactors = FALSE
)


# combine and save as .csv spreadsheet file

df_combined <- rbind(
  df_Xenium_small, 
  df_CosMx_small, 
  df_MERSCOPE_small, 
  df_STARmapPLUS_small,
  df_seqFISH_small
)

write.csv(df_combined, file = "./inst/extdata/metadata.csv", row.names = FALSE)

################################################################################
# Script to create a small count matrix and a small coordinate files 
# from the raw download of the CosMx human lung cancer
# patient 9 slice 1.
# Yixing Dong, updated Aug 2024
################################################################################

# references:
# CosMx `_exprMat_file.csv` and `_metadata_file.csv` file were downloaded from
# \url{https://nanostring.com/resources/smi-ffpe-dataset-lung9-rep1-data/}

# in this script we subset the large raw necessary files into small ones.


# -------------
# Download data
# -------------

# Put the downloaded unzipped file into a folder. Make sure that two mandatory 
# files do exist. 

cosmx_lung_p9s1_path <- here::here("raw_data/cosmx_patient9slice1")
cosmx_folder <- list.files(cosmx_lung_p9s1_path, pattern = ".csv")
cosmx_folder


# -------------
# Read in raw data
# -------------

counts <- read.csv(file.path(cosmx_lung_p9s1_path, "Lung5_Rep1_exprMat_file.csv")) # 91992   982
meta <- read.csv(file.path(cosmx_lung_p9s1_path, "Lung5_Rep1_metadata_file.csv"))  # 91972    20

# -------------
# Downsize to 10 genes and 9 cells 
# -------------

library(dplyr)
counts_test <- counts %>%
  dplyr::filter(fov %in% c(10)) %>%
  slice(1:10) %>%
  dplyr::filter(cell_ID != 0) # take 9 cells

counts_test <- counts_test[, 1:10] # take 10 genes

meta_test <- meta %>%
  right_join(counts_test[, c("fov", "cell_ID")], by = c("fov", "cell_ID")) %>%
  select("fov", "cell_ID", "Area", "CenterX_local_px", "CenterY_local_px", "CenterX_global_px", "CenterY_global_px")

# -------------
# Save the small data 
# -------------

cosmx_lung_p9s1_demo_path <- "~/Desktop/SpatialExperimentIO/inst/extdata/CosMx_small"
write.csv(counts_test, file.path(cosmx_lung_p9s1_demo_path, "lung_p9s1_exprMat_file.csv"), row.names = FALSE)
write.csv(meta_test, file.path(cosmx_lung_p9s1_demo_path, "lung_p9s1_metadata_file.csv"), row.names = FALSE)

# -------------
# Downsize to 10 genes and 9 cells for transcripts 
# -------------
path_to_tx <- "~/Downloads/Lung9_Rep1"
tx_cssv <- read.csv(file.path(path_to_tx, "Lung9_Rep1_tx_file.csv"))

# counts_test <- read.csv(file.path(cosmx_lung_p9s1_demo_path, "lung_p9s1_exprMat_file.csv"), row.names = FALSE)
ten_genes <- c("AATK","ABL1","ABL2","ACE","ACE2","ACKR1","ACKR3","ACKR4")
nine_cells <- 1:9
fov <- 10

tx_cssv_test <- tx_cssv %>%
  filter(fov == 10 & cell_ID %in% 1:9 & target %in% ten_genes)
  
write.csv(tx_cssv_test, file.path(cosmx_lung_p9s1_demo_path, "lung_p9s1_tx_file.csv"), row.names = FALSE) # only 1 row

# add to gitignore to mimic raw file download, but use locally for testing
arrow::write_parquet(tx_cssv_test, file.path(cosmx_lung_p9s1_demo_path, "tx_file.parquet"))  
# tx_cssv_test <- arrow::read_parquet(file.path(cosmx_lung_p9s1_demo_path, "tx_file.parquet")) # sanity


# -------------
# Downsize to 10 genes and 9 cells for fov position
# -------------
path_to_tx <- "~/Downloads/Lung9_Rep1"
fov_cssv <- read.csv(file.path(path_to_tx, "Lung9_Rep1_fov_positions_file.csv"))

fov_cssv_test <- fov_cssv %>%
  filter(fov == 10)

write.csv(fov_cssv_test, file.path(cosmx_lung_p9s1_demo_path, "lung_p9s1_fov_positions_file.csv"), row.names = FALSE) # only 1 row

################################################################################
# Script to create a small count matrix and a small coordinate files 
# from the raw download of the STARmap PLUS mouse brain
# well 05.
# Yixing Dong, updated Aug 2024
################################################################################

# references:
# STARmap PLUS `raw_expression_pd.csv` and `spatial.csv` file were downloaded from
# \url{https://zenodo.org/records/8327576}

# in this script we subset the large raw necessary files into small ones.


# -------------
# Download data
# -------------
# Put the downloaded unzipped file into a folder. Make sure that two mandatory 
# files do exist. 
star_well05_path <- here::here("raw_data/star_well05")
star_folder <- list.files(star_well05_path, pattern = ".csv")
star_folder


# -------------
# Read in raw data
# -------------

counts <- read.csv(file.path(star_well05_path, "well05raw_expression_pd.csv")) # 91992   982
meta <- read.csv(file.path(star_well05_path, "well05_spatial.csv"))  # 91972    20


# -------------
# Downsize to 8 genes and 9 cells 
# -------------

library(dplyr)
meta_test <- meta %>%
  slice(1:10)  # take 9 cells 

cells <- meta_test$NAME[meta_test$NAME != "TYPE"]

counts_test <- counts %>%
  slice(1:8) # take 8 genes

counts_test <- counts_test[, colnames(counts_test) %in% c("GENE", cells)]


# -------------
# Save the small data 
# -------------

starmap_mousebrain_demo_path <- "~/Desktop/SpatialExperimentIO/inst/extdata/STARmapPLUS_small"
write.csv(counts_test, file.path(starmap_mousebrain_demo_path, "mockraw_expression_pd.csv"), row.names = FALSE)
write.csv(meta_test, file.path(starmap_mousebrain_demo_path, "mock_spatial.csv"), row.names = FALSE)


# -------------
# Sanity check
# -------------

# install necessary packages

devtools::install_github("estellad/SpatialExperimentIO")
remotes::install_github("lmweber/ggspavis")

# load packages

library(SpatialExperimentIO)
library(ggspavis)

# read the small data as SPE object, and plot it. 

spe <- readStarmapplusSXE(starmap_mousebrain_demo_path, return_type = "SPE")
plotSpots(spe, annotate = "Main_molecular_cell_type", in_tissue = NULL)

#' Add CosMx-related parquet paths to metadata for transcripts, polygon, or cell/nucleus boundaries.
#' 
#' @param sxe a SPE or SCE Xenium object to add parquet to `metadata(sxe)`.
#' @param dirName the directory that stores the transcripts/polygon 
#' .csv or .parquet files.
#' @param addTx to add path to transcripts parquet to \code{metadata(sxe)}or not. 
#' Default is TRUE. 
#' @param txMetaNames names to add to slots in \code{metadata(sxe)[["name"]]}. 
#' The number of `txMetaNames` should equal to number of file detected in `dirName` 
#' with `txPattern`. Can have multiple, such as \code{c("transcripts", "transcripts1")}. 
#' Default is \code{"transcripts"}.
#' @param txPattern .csv or .parquet (if you have previous converted) pattern 
#' of transcript file in `dirName`. Can have multiple, such as \code{c("tx_file.csv", "tx_file1.csv")}. 
#' Default value is \code{"tx_file.csv"}.
#' @param addPolygon to add path to polygons parquet to \code{metadata(sxe)} or not. 
#' Default is TRUE.
#' @param polygonMetaNames names to add to slots in `metadata(sxe)$`. The number of 
#' `polygonMetaNames` should equal to number of file detected in `dirName` with `polygonPattern`.
#' Can have multiple. Can have multiple, such as \code{c("polygons", "polygons1")}. 
#' Default is \code{"transcripts"}.
#' @param polygonPattern .csv or .parquet (if you have previous converted) pattern
#'  of polygons file in the `dirName`. Can have multiple, such as \code{c("polygons.csv", "polygons1.csv")}. 
#' Default value is \code{"polygons.csv"}. 
#' 
#' @author Yixing Estella Dong
#' 
#' @return a SPE or SCE Xenium object with parquet paths added to metadata
#' @export 
#' 
#' @examples 
#' cospath <- system.file(file.path("extdata", "CosMx_small"), 
#'                        package = "SpatialExperimentIO")
#' 
#' sxe <- readCosmxSXE(dirName = cospath, addParquetPaths = FALSE)
#' sxe <- addParquetPathsCosmx(sxe, dirName = cospath, addPolygon = FALSE)
#'
addParquetPathsCosmx <- function(sxe,
                                 dirName, 
                                 addTx = TRUE,
                                 txMetaNames = "transcripts",
                                 txPattern = "tx_file.csv", 
                                 addPolygon = TRUE,
                                 polygonMetaNames = "polygons",
                                 polygonPattern = "polygons.csv"){
  
  # Transcripts
  if(addTx) sxe <- addParquetPathToMeta(sxe, dirName = dirName,
                                         metaNames = txMetaNames,
                                         filePattern = txPattern)
  
  # Polygon
  if(addPolygon) sxe <- addParquetPathToMeta(sxe, dirName = dirName,
                                              metaNames = polygonMetaNames,
                                              filePattern = polygonPattern)
  
  return(sxe)
}


#' Add Xenium-related parquet paths to metadata for transcripts or cell/nucleus boundaries.
#' 
#' @param sxe a SPE or SCE Xenium object to add parquet to `metadata(sxe)`.
#' @param dirName the directory that stores the transcripts/cell_boundaries/nucleus_boundaries 
#' .parquet files.
#' @param addTx to add path to transcripts parquet to \code{metadata(sxe)} or not. 
#' Default is FALSE. 
#' @param txMetaNames names to add to slots in \code{metadata(sxe)[["name"]]}. 
#' The number of `txMetaNames` should equal to number of file detected in `dirName` 
#' with `txPattern`. Can have multiple, such as \code{c("transcripts", "transcripts1")}. 
#' Default is \code{"transcripts"}.
#' @param txPattern .parquet pattern of transcript file in `dirName`. Can have multiple, 
#' such as \code{c("transcripts.parquet", "transcripts1.parquet")}. Default value is 
#' \code{"transcripts.parquet"}.
#' @param addCellBound to add path to cell boundaries parquet to \code{metadata(sxe)} or not. 
#' Default is FALSE. 
#' @param cellBoundMetaNames names to add to slots in \code{metadata(sxe)[["name"]]}. 
#' The number of `cellBoundMetaNames` should equal to number of file detected in `dirName` 
#' with `cellBoundPattern`. Can have multiple, such as \code{c("cell_boundaries", "cell_boundaries1")}. 
#' Default is \code{"cell_boundaries"}.
#' @param cellBoundPattern .parquet pattern of cell boundaries file in `dirName`. Can have multiple, 
#' such as \code{c("cell_boundaries.parquet", "cell_boundaries1.parquet")}. Default value is 
#' \code{"cell_boundaries.parquet"}.
#' @param addNucBound to add path to nucleus boundaries parquet to \code{metadata(sxe)} or not. 
#' Default is FALSE. 
#' @param NucBoundMetaNames names to add to slots in \code{metadata(sxe)[["name"]]}. 
#' The number of `NucBoundMetaNames` should equal to number of file detected in `dirName` 
#' with `NucBoundPattern`. Can have multiple, such as \code{c("nucleus_boundaries", "nucleus_boundaries1")}. 
#' Default is \code{"nucleus_boundaries"}.
#' @param NucBoundPattern .parquet pattern of nucleus boundaries file in `dirName`. Can have multiple, 
#' such as \code{c("nucleus_boundaries.parquet", "nucleus_boundaries1.parquet")}. Default value is 
#' \code{"nucleus_boundaries.parquet"}.
#' 
#' @author Yixing Estella Dong
#' 
#' @return a SPE or SCE Xenium object with parquet paths added to metadata
#' @export 
#'
#' @examples 
#' xepath <- system.file(file.path("extdata", "Xenium_small"),
#'                       package = "SpatialExperimentIO")
#' 
#' sxe <- readXeniumSXE(dirName = xepath, addParquetPaths = FALSE)
#' sxe <- addParquetPathsXenium(sxe, dirName = xepath)
#'
addParquetPathsXenium <- function(sxe, 
                                  dirName,
                                  addTx = TRUE,
                                  txMetaNames = "transcripts",
                                  txPattern = "transcripts.parquet", 
                                  addCellBound = TRUE,
                                  cellBoundMetaNames = "cell_boundaries",
                                  cellBoundPattern = "cell_boundaries.parquet", 
                                  addNucBound = TRUE,
                                  NucBoundMetaNames = "nucleus_boundaries",
                                  NucBoundPattern = "nucleus_boundaries.parquet"){
  
  # Transcripts
  if(addTx) sxe <- addParquetPathToMeta(sxe, dirName = dirName,
                                         metaNames = txMetaNames,
                                         filePattern = txPattern)
  
  # Cell Boundaries
  if(addCellBound) sxe <- addParquetPathToMeta(sxe, dirName = dirName,
                                                metaNames = cellBoundMetaNames,
                                                filePattern = cellBoundPattern)
  
  # Nucleus Boundaries
  if(addNucBound) sxe <- addParquetPathToMeta(sxe, dirName = dirName,
                                               metaNames = NucBoundMetaNames,
                                               filePattern = NucBoundPattern)
  
  return(sxe)
}

dir <- system.file(
  file.path("extdata", "MERSCOPE_small"), 
  package="SpatialExperimentIO")

test_that("example data folders uniquely contains needed files", {
  expect_true("ovarian_p2s2_cell_by_gene.csv" %in% list.files(dir))
  expect_true("ovarian_p2s2_cell_metadata.csv" %in% list.files(dir)) 
  
  expect_length(list.files(dir, "cell_by_gene.csv"), 1)
  expect_length(list.files(dir, "cell_metadata.csv"), 1)
})

test_that("needed files contains spatial columns of interest", {
  metadata <- read.csv(file.path(dir, "ovarian_p2s2_cell_metadata.csv"))
  
  expect_true(all(c("center_x", "center_y") %in% colnames(metadata))) 
  expect_true(is.numeric(metadata$center_x))
  expect_true(is.numeric(metadata$center_y))
})

test_that("data are read correctly to SpatialExperiment class", {
  x <- readMerscopeSXE(dirName = dir, 
                       returnType = "SPE",
                       countMatPattern = "cell_by_gene.csv", 
                       metaDataPattern = "cell_metadata.csv", 
                       coordNames = c("center_x", "center_y"))
  
  expect_s4_class(x, "SpatialExperiment")
  expect_true(all(colnames(SpatialExperiment::spatialCoords(x)) == c("center_x", "center_y")))
  expect_false(is.null(rownames(x)))
  expect_false(is.null(colnames(x)))
  expect_true(all(dim(x) == c(9, 8)))
  expect_s4_class(SingleCellExperiment::counts(x), "dgCMatrix")
})

test_that("data are read correctly to SingleCellExperiment class", {
  x <- readMerscopeSXE(dirName = dir, 
                       returnType = "SCE",
                       countMatPattern = "cell_by_gene.csv", 
                       metaDataPattern = "cell_metadata.csv", 
                       coordNames = c("center_x", "center_y"))
  
  expect_s4_class(x, "SingleCellExperiment")
  expect_true(all(c("center_x", "center_y") %in% colnames(SingleCellExperiment::colData(x))))
  expect_false(is.null(rownames(x)))
  expect_false(is.null(colnames(x)))
  expect_true(all(dim(x) == c(9, 8)))
  expect_s4_class(SingleCellExperiment::counts(x), "dgCMatrix")
})

---
title: "SpatialExperimentIO - Data Reader Package Overview"
author:   
  - name: Yixing E. Dong
    affiliation: "University of Lausanne, Lausanne, Switzerland"
output: 
  BiocStyle::html_document:
  self_contained: yes
  toc: true
  toc_float: true
  toc_depth: 2
  code_folding: show
date: "`r format(Sys.Date(), '%b %d, %Y')`"
vignette: >
    %\VignetteIndexEntry{SpatialExperimentIO Reader Package Overview}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---

```{=html}
<style type="text/css"> .smaller { font-size: 10px } </style>
```
```{r setup, include = FALSE}
knitr::opts_chunk$set(cache = TRUE, autodep = TRUE, cache.lazy = FALSE)
```

This package allows the user to decide to load data from single-cell level spatial transcriptomics technologies, such as Xenium, CosMx, MERSCOPE, STARmapPLUS, or seqFISH as either `SpatialExperiment (SPE)` or `SingleCellExperiment (SCE)` object.

The only difference between the two object types are where to store the spatial coordinates. For the current version of `SpatialExperiment`, the `spatialCoords(spe)` are stored in a separate slot other than `colData(spe)`. On the other hand, `SingleCellExperiment` stores the `spatialCoords()` inside of `colData(spe)`.

After reading in the data, we need to look at the landscape of other downstream analysis tools. For example, `library(BayesSpace)` is a clustering tool developed for spatial transcriptomics data, but it only takes a `SCE` object and looks for the spatial coordinates in the `colData(sce)`. Other spatial visualization packages, such as `library(ggspavis)` in its newest version, is compatible with both `SPE` and `SCE` objects.

Therefore, to avoid the pain of object conversion, we give the flexibility to let the user decide what object type to return.

# Setup

```{r, warning=FALSE, message=FALSE}
suppressMessages({
  library(SpatialExperimentIO)
  library(SpatialExperiment)
})
```

# Quick Start

-   For Xenium data:

```{r, eval=FALSE}
### DO NOT RUN. Example code.
xepath <- "/path/to/folder"
# Xenium as SPE, or SCE by setting `returnType = "SCE"`.
xe_spe <- readXeniumSXE(dirName = xepath)
```

-   For CosMx data:

```{r, eval=FALSE}
### DO NOT RUN. Example code.
cospath <- "/path/to/folder"
# CosMx as SPE, or SCE by setting `returnType = "SCE"`.
cos_spe <- readCosmxSXE(dirName = cospath)
```

-   For MERSCOPE data:

```{r, eval=FALSE}
### DO NOT RUN. Example code.
merpath <- "/path/to/folder"
# MERSCOPE as SPE, or SCE by setting `returnType = "SCE"`.
mer_spe <- readMerscopeSXE(dirName = merpath)
```

-   For STARmap PLUS data:

```{r, eval=FALSE}
### DO NOT RUN. Example code.
starpath <- "/path/to/folder"
# STARmapPLUS as SPE, or SCE by setting `returnType = "SCE"`.
star_spe <- readStarmapplusSXE(dirName = starpath)
```


-   For seqFISH data:

```{r, eval=FALSE}
### DO NOT RUN. Example code.
seqfpath <- "/path/to/folder"
# seqFISH as SPE, or SCE by setting `returnType = "SCE"`.
seqf_spe <- readSeqfishSXE(dirName = merpath)
```

That is pretty much all you need. To learn more details, please read the below sections for each technology.



# Xenium

Xenium is an imaging-based in-situ sequencing technology developed by 10x Genomics. Compared to the full transcriptome coverage sequencing-based technology Visium, Xenium allows for transcript-level resolution count detection but with less genes. The transcripts are segmented into single cells and `SpatialExperimentIO` returns the cell-level `SPE` or `SCE` object. To read more about Xenium technology workflow, please refer to the [Xenium technology overview](https://www.10xgenomics.com/blog/spatially-resolved-transcriptomics-an-introductory-overview-of-spatial-gene-expression-profiling-methods). For more publicly available Xenium data, please refer to [Xenium data download](https://www.10xgenomics.com/datasets?query=Xenium&page=1&configure%5BhitsPerPage%5D=50&configure%5BmaxValuesPerFacet%5D=1000).

The object constructor assumes the downloaded unzipped Xenium Output Bundle contains the mandatory file of `cells.parquet` and either a folder `/cell_feature_matrix` or a .h5 file `cell_feature_matrix.h5`.

```{r}
xepath <- system.file(
  file.path("extdata", "Xenium_small"),
  package = "SpatialExperimentIO")

list.files(xepath)
```

## Read Xenium as a `SpatialExperiment` object

We display the default specification of each variable in `readXeniumSXE()`. To read in Xenium as a `SpatialExperiment` object with count matrix, column data, and all other common raw download files, you would only need to provide a valid directory name.

```{r, eval=FALSE}
# read the count matrix .h5 file - automatically DropletUtils::read10xCounts(type = "HDF5")
xe_spe <- readXeniumSXE(dirName = xepath,
                        returnType = "SPE",
                        countMatPattern = "cell_feature_matrix.h5",
                        metaDataPattern = "cells.parquet",
                        coordNames = c("x_centroid", "y_centroid"),
                        addExperimentXenium = TRUE, # set to TRUE to load experiment.xenium
                        altExps = c("NegControlProbe", "UnassignedCodeword",
                                    "NegControlCodeword", "antisense", "BLANK"),
                        addParquetPaths = TRUE #, # set TRUE to load all .parquet below
                        # ... # takes arguments as below
                        ) 
xe_spe <- addParquetPathsXenium(sxe = xe_spe,
                                dirName = xepath,
                                addTx = TRUE,
                                txMetaNames = "transcripts",
                                txPattern = "transcripts.parquet",
                                addCellBound = TRUE,
                                cellBoundMetaNames = "cell_boundaries",
                                cellBoundPattern = "cell_boundaries.parquet",
                                addNucBound = TRUE,
                                NucBoundMetaNames = "nucleus_boundaries",
                                NucBoundPattern = "nucleus_boundaries.parquet")
```


Note that `experiment.xenium` is by default added to `metaata()`, and you can disable it by setting `addExperimentXenium = FALSE`.

```{r}
xe_spe <- readXeniumSXE(dirName = xepath)
xe_spe
```

Additionally, Xenium gives different control genes in their gene panel (check with `altExpNames(xe_spe)` to see). In this mini example, we obtain a Xenium dataset with 4 genes all with type of `"Gene Expression"` in their `rowData(xe_spe)` and 6 cells just for illustration. In a real Xenium data download, possible `altExp(xe_spe)` for Xenium can have the default categories, depending on the experiment setup. For example, below we manually specified gene names contains "TestGene" will be put into `altExp()`. We add any other .parquet files (`cell_boundaries.parquet`, `nucleus_boundaries.parquet`), except `transcripts.parquet`, to the `metadata()`. You can control what path to add with additional boolean arguments - `addTx`, `addCellBound`, `addNucBound`. See the documentation for the helper function `addParquetPathsXenium()`.

```{r}
xe_spe <- readXeniumSXE(xepath,
                        altExps = c("TestGene"),
                        addParquetPaths = TRUE,
                        addTx = FALSE)
xe_spe
```

If you do not have `cell_feature_matrix.h5` but the folder `/cell_feature_matrix` instead, it should contain the following files.

```{r, eval=FALSE}
list.files(file.path(xepath, "cell_feature_matrix"))
# "barcodes.tsv.gz" "features.tsv.gz" "matrix.mtx.gz"
```

For this example, we only provide `cell_feature_matrix.h5` for demonstration. However, alternatively you can read in Xenium by specifying `countMatPattern` as the folder `"cell_feature_matrix"`. You should also subset to `"Gene Expression"` gene type like previously.

```{r, eval=FALSE}
# or read the count matrix folder - automatically DropletUtils::read10xCounts(type = "sparse")
xe_spe <- readXeniumSXE(dirName = xepath,
                        countMatPattern = "cell_feature_matrix")
```

## Read Xenium as a `SingleCellExperiment` object

Instead, if you are interested in storing the `spatialCoords()` columns in `colData` and read Xenium in as a `SingleCellExperiment`, you need to change `readXeniumSXE(returnType = )` to `"SCE"`. It is also required to subset to `"Gene Expression"` gene type. We end up with an `SCE` object with 248 genes.

```{r}
xe_sce <- readXeniumSXE(dirName = xepath, returnType = "SCE")
xe_sce
```

This is a mock Xenium datasets with 4 genes by 6 cells. Some Xenium data set can have a dimension of 313 genes and around 110,000 cells in the [Xenium human breast cancer data](https://www.10xgenomics.com/products/xenium-in-situ/preview-dataset-human-breast).

For more visualization tools for spatial transcriptomics downstream data analysis, including helpers for QC, marker gene expression level and clustering results on reduced dimensions or its spatial distribution, please refer to `BiocManager::install("ggspavis")`.



# CosMx

CosMx is an imaging-based in-situ sequencing technology by Nanostring. To read more about the CosMx technology workflow, please refer to the [technology overview](https://nanostring.com/products/cosmx-spatial-molecular-imager/single-cell-imaging-overview/). For more publicly available data sets, please refer to the CosMx data download [website](https://nanostring.com/products/cosmx-spatial-molecular-imager/ffpe-dataset/?utm_source=google&utm_medium=paidsearch&utm_campaign=dynamic&utm_id=NSTG_DynamicSearch&utm_source=google&utm_medium=cpc&utm_campaign=1765548394&utm_agid=132844584222&utm_term=&creative=592729435866&device=c&placement=&network=g&gad_source=1&gclid=EAIaIQobChMI5M-sztjIggMVZZFoCR1MLgFiEAAYASAAEgJ1L_D_BwE).

The object constructor assumes the data download folder contains two mandatory files with `exprMat_file.csv` and `metadata_file.csv` in the names.

```{r}
cospath <- system.file(
  file.path("extdata", "CosMx_small"),
  package = "SpatialExperimentIO")

list.files(cospath)
```

## Read CosMx as a `SpatialExperiment` object

We commented out the default specification of each variable in `readCosmxSXE()`. To read in CosMx as a `SpatialExperiment` object, you would only need to provide a valid directory name. 

```{r, eval=FALSE}
cos_spe <- readCosmxSXE(dirName = cospath,
                        returnType = "SPE",
                        countMatPattern = "exprMat_file.csv",
                        metaDataPattern = "metadata_file.csv",
                        coordNames = c("CenterX_global_px", "CenterY_global_px"),
                        addFovPos = TRUE, # set to TRUE to add fov position columns to colData()
                        fovPosPattern = "fov_positions_file.csv",
                        altExps = c("NegPrb", "Negative", "SystemControl", "FalseCode"),
                        addParquetPaths = TRUE # , # set TRUE to add all .parquet below
                        # ... # takes arguments as below
                        ) 
cos_spe <- addParquetPathsCosmx(sxe = cos_spe,
                                dirName = cospath,
                                addTx = TRUE,
                                txMetaNames = "transcripts",
                                txPattern = "tx_file.csv",
                                addPolygon = TRUE,
                                polygonMetaNames = "polygons",
                                polygonPattern = "polygons.csv")
```


With this example dataset, we obtained a CosMx `SPE` object with 8 genes and 9 cells. Here is a demonstration of adding all recommended files as path to parquet in the `metadata()`, except there is no polygon file in this example data. 

```{r}
cos_spe <- readCosmxSXE(cospath,
                        addPolygon = FALSE)
cos_spe
```

## Read CosMx as a `SingleCellExperiment` object

Alternatively, you can also read CosMx in as a `SCE`.

```{r}
cos_sce <- readCosmxSXE(dirName = cospath, addPolygon = FALSE, returnType = "SCE")
cos_sce
```

In reality, a CosMx data set can have a dimension of 980 genes and around 100,000 cells for the [human lung cancer data](https://nanostring.com/products/cosmx-spatial-molecular-imager/ffpe-dataset/nsclc-ffpe-dataset/?utm_source=google&utm_medium=paidsearch&utm_campaign=dynamic&utm_id=NSTG_DynamicSearch&utm_source=google&utm_medium=cpc&utm_campaign=1765548394&utm_agid=132844584222&utm_term=&creative=592729435866&device=c&placement=&network=g&gad_source=1&gclid=EAIaIQobChMIv-DvtO_IggMVlotoCR0qtgdxEAAYASAAEgKi0vD_BwE).



# MERSCOPE

MERSCOPE integrated MERFISH spatial transcriptomics technology with high resolution spatial imaging, fluidics, image processing, and is a product by Vizgen. To understand more about the MERFISH technology behind MERSCOPE, please refer to the [MERFISH Technology Overview](https://vizgen.com/technology/#merfish). For more publicly available MERSCOPE data, please see [MERSCOPE data download page](https://info.vizgen.com/ffpe-showcase).

The object constructor assumes the data download folder contains two mandatory files with `cell_by_gene.csv` and `cell_metadata.csv` in the names.

```{r}
merpath <- system.file(
  file.path("extdata", "MERSCOPE_small"),
  package = "SpatialExperimentIO")

list.files(merpath)
```

## Read MERSCOPE as a `SpatialExperiment` object

We commented out the default specification of each variable in `readMerscopeSXE()`. To read in MERSCOPE as a `SpatialExperiment` object, you would only need to provide a valid directory name. With this example dataset, we obtained a MERSCOPE `SPE` object with 9 genes and 8 cells.

```{r}
# mer_spe <- readMerscopeSXE(dirName = merpath, 
#                            returnType = "SPE",
#                            countMatPattern = "cell_by_gene.csv", 
#                            metaDataPattern = "cell_metadata.csv", 
#                            coordNames = c("center_x", "center_y"))

mer_spe <- readMerscopeSXE(dirName = merpath)
mer_spe
```

## Read MERSCOPE as a `SingleCellExperiment` object

Alternatively, you can also read MERSCOPE in as a `SCE`.

```{r}
mer_sce <- readMerscopeSXE(dirName = merpath, returnType = "SCE")
mer_sce
```

In reality, a MERSCOPE data set can have a dimension of 550 genes and around 250,000 cells for the [human ovarian cancer data](https://console.cloud.google.com/storage/browser/vz-ffpe-showcase/HumanOvarianCancerPatient2Slice1?pageState=(%22StorageObjectListTable%22:(%22f%22:%22%255B%255D%22))).



# STARmap PLUS

STARmap PLUS is an imaging-based in-situ sequencing technology that has been introduced by [Zeng et al.](https://pubmed.ncbi.nlm.nih.gov/36732642/). The object constructor assumes the data download folder contains two mandatory files with `raw_expression_pd.csv` and `spatial.csv` in the names.

```{r}
starpath <- system.file(
  file.path("extdata", "STARmapPLUS_small"),
  package = "SpatialExperimentIO")

list.files(starpath)
```

## Read STARmap PLUS as a `SpatialExperiment` object

We comment out the default parameters for your reference. In this example dataset, we provide a sample with 8 genes and 9 cells just for illustration.

```{r}
# readStarmapplusSXE <- function(dirName = dirName, 
#                                returnType = "SPE",
#                                countMatPattern = "raw_expression_pd.csv", 
#                                metaDataPattern = "spatial.csv", 
#                                coordNames = c("X", "Y", "Z"))

star_spe <- readStarmapplusSXE(dirName = starpath)
star_spe
```

## Read STARmap PLUS as a `SingleCellExperiment` object

Alternatively, you can also return a `SingleCellExperiment` object.

```{r}
star_sce <- readStarmapplusSXE(dirName = starpath, returnType = "SCE")
star_sce
```

STARmap PLUS has a gene panel of around 1000 with up to millions of cells depending on the size of the tissue. There are 20 sample on mouse brain with tissue region annotated published by [Shi et al.](https://www.nature.com/articles/s41586-023-06569-5). Their data is avaiable to downloaded from [Zenodo](https://zenodo.org/records/8327576).



# seqFISH

seqFISH is a product by Spatial Genomics, generated by the GenePS device. Like Xenium, it is claimed to work on intact cells and tissues. To understand more about the seqFISH technology, please refer to their website [seqFISH Technology Overview](https://spatialgenomics.com/). For more publicly available seqFISH data, please see [seqFISH data download page](https://spatialgenomics.com/data/).

The object constructor assumes the data download folder contains two mandatory files with `CellxGene.csv` and `CellCoordinates.csv` in the names.

```{r}
seqfpath <- system.file(
  file.path("extdata", "seqFISH_small"),
  package = "SpatialExperimentIO")

list.files(seqfpath)
```

## Read seqFISH as a `SpatialExperiment` object

We commented out the default specification of each variable in `readSeqfishSXE()`. To read in seqFISH as a `SpatialExperiment` object, you would only need to provide a valid directory name. With this example dataset, we obtained a seqFISH `SPE` object with 9 genes and 14 cells.

```{r}
# seqf_spe <- readSeqfishSXE(dirName = seqfpath, 
#                            returnType = "SPE",
#                            countMatPattern = "cell_by_gene.csv", 
#                            metaDataPattern = "cell_metadata.csv", 
#                            coordNames = c("center_x", "center_y"))

seqf_spe <- readSeqfishSXE(dirName = seqfpath)
seqf_spe
```

## Read seqFISH as a `SingleCellExperiment` object

Alternatively, you can also read seqFISH in as a `SCE`.

```{r}
seqf_sce <- readSeqfishSXE(dirName = seqfpath, returnType = "SCE")
seqf_sce
```

So far, publicly available seqFISH data sets have 220 or 1092 genes in a panel for mouse kidney, for about 669,842 cells. There are other mouse indications, such as brain, liver, and intestine. There might be human colorectal and gastric cancer samples in the upcoming future. 


# Session Info {.smaller}

```{r tidy = TRUE}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{.sanityCheck}
\alias{.sanityCheck}
\title{Sanity check if one and only file with the specified name pattern exists in
the data download directory, and return the file path to .csv
Used for count matrix and metadata only, as they require unique.}
\usage{
.sanityCheck(tech, filetype, expectfilename, dirName, filepatternvar)
}
\arguments{
\item{tech}{Name of technology. Defined at the beginning of the function. e.g. "CosMx"}

\item{filetype}{File type to do sanity check. e.g. "metadata"}

\item{expectfilename}{Expected file pattern name for this file type. e.g. "metadata_file.csv"}

\item{dirName}{Directory to the data download.}

\item{filepatternvar}{The file pattern variable. e.g. "metaDataPattern"}
}
\value{
a path to a unique file of count matrix or colData.
}
\description{
Sanity check if one and only file with the specified name pattern exists in
the data download directory, and return the file path to .csv
Used for count matrix and metadata only, as they require unique.
}
\examples{
\dontrun{
dir <- system.file(file.path("extdata", "CosMx_small"),
                   package = "SpatialExperimentIO")
countmat_file <- SpatialExperimentIO:::.sanityCheck(tech = "CosMx", 
                              filetype = "count matrix",
                              expectfilename = "`exprMat_file.csv`",
                              dirName = dir,
                              filepatternvar = "exprMat_file.csv")
}
}
\author{
Yixing Estella Dong
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/addParquetPaths.R
\name{addParquetPathsXenium}
\alias{addParquetPathsXenium}
\title{Add Xenium-related parquet paths to metadata for transcripts or cell/nucleus boundaries.}
\usage{
addParquetPathsXenium(
  sxe,
  dirName,
  addTx = TRUE,
  txMetaNames = "transcripts",
  txPattern = "transcripts.parquet",
  addCellBound = TRUE,
  cellBoundMetaNames = "cell_boundaries",
  cellBoundPattern = "cell_boundaries.parquet",
  addNucBound = TRUE,
  NucBoundMetaNames = "nucleus_boundaries",
  NucBoundPattern = "nucleus_boundaries.parquet"
)
}
\arguments{
\item{sxe}{a SPE or SCE Xenium object to add parquet to \code{metadata(sxe)}.}

\item{dirName}{the directory that stores the transcripts/cell_boundaries/nucleus_boundaries
.parquet files.}

\item{addTx}{to add path to transcripts parquet to \code{metadata(sxe)} or not.
Default is FALSE.}

\item{txMetaNames}{names to add to slots in \code{metadata(sxe)[["name"]]}.
The number of \code{txMetaNames} should equal to number of file detected in \code{dirName}
with \code{txPattern}. Can have multiple, such as \code{c("transcripts", "transcripts1")}.
Default is \code{"transcripts"}.}

\item{txPattern}{.parquet pattern of transcript file in \code{dirName}. Can have multiple,
such as \code{c("transcripts.parquet", "transcripts1.parquet")}. Default value is
\code{"transcripts.parquet"}.}

\item{addCellBound}{to add path to cell boundaries parquet to \code{metadata(sxe)} or not.
Default is FALSE.}

\item{cellBoundMetaNames}{names to add to slots in \code{metadata(sxe)[["name"]]}.
The number of \code{cellBoundMetaNames} should equal to number of file detected in \code{dirName}
with \code{cellBoundPattern}. Can have multiple, such as \code{c("cell_boundaries", "cell_boundaries1")}.
Default is \code{"cell_boundaries"}.}

\item{cellBoundPattern}{.parquet pattern of cell boundaries file in \code{dirName}. Can have multiple,
such as \code{c("cell_boundaries.parquet", "cell_boundaries1.parquet")}. Default value is
\code{"cell_boundaries.parquet"}.}

\item{addNucBound}{to add path to nucleus boundaries parquet to \code{metadata(sxe)} or not.
Default is FALSE.}

\item{NucBoundMetaNames}{names to add to slots in \code{metadata(sxe)[["name"]]}.
The number of \code{NucBoundMetaNames} should equal to number of file detected in \code{dirName}
with \code{NucBoundPattern}. Can have multiple, such as \code{c("nucleus_boundaries", "nucleus_boundaries1")}.
Default is \code{"nucleus_boundaries"}.}

\item{NucBoundPattern}{.parquet pattern of nucleus boundaries file in \code{dirName}. Can have multiple,
such as \code{c("nucleus_boundaries.parquet", "nucleus_boundaries1.parquet")}. Default value is
\code{"nucleus_boundaries.parquet"}.}
}
\value{
a SPE or SCE Xenium object with parquet paths added to metadata
}
\description{
Add Xenium-related parquet paths to metadata for transcripts or cell/nucleus boundaries.
}
\examples{
xepath <- system.file(file.path("extdata", "Xenium_small"),
                      package = "SpatialExperimentIO")

sxe <- readXeniumSXE(dirName = xepath, addParquetPaths = FALSE)
sxe <- addParquetPathsXenium(sxe, dirName = xepath)

}
\author{
Yixing Estella Dong
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readStarmapplusSXE.R
\name{readStarmapplusSXE}
\alias{readStarmapplusSXE}
\title{Load data from a STARmap PLUS experiment}
\usage{
readStarmapplusSXE(
  dirName = dirName,
  returnType = "SPE",
  countMatPattern = "raw_expression_pd.csv",
  metaDataPattern = "spatial.csv",
  coordNames = c("X", "Y", "Z")
)
}
\arguments{
\item{dirName}{a directory path to STARmap PLUS download that contains files of interest.}

\item{returnType}{option of \code{"SPE"} or \code{"SCE"}, stands for
\code{SpatialExperiment} or \code{SingleCellExperiment} object. Default value \code{"SPE"}}

\item{countMatPattern}{a filename pattern for the count matrix. Default value is
\code{"raw_expression_pd.csv"}, and there is no need to change.}

\item{metaDataPattern}{a filename pattern for the metadata .csv file that
contains spatial coords. Default value is \code{"spatial.csv"}, and
there is no need to change.}

\item{coordNames}{a vector of three strings specify the spatial coord names.
Default value is \code{c("X", "Y", "Z")}, and there is no need to change.}
}
\value{
a \code{\link{SpatialExperiment}} or a \code{\link{SingleCellExperiment}} object
}
\description{
Creates a \code{\link{SpatialExperiment}} from the downloaded STARmap PLUS count
matrix.csv and metadata.csv
}
\details{
The constructor assumes the downloaded unzipped STARmap PLUS folder has the following
structure, with two mandatory files:
STARmap_PLUS_download/ \cr
· | — *raw_expression_pd.csv \cr
· | — *spatial.csv \cr
}
\examples{
# A relatively small data download can be from:
# https://zenodo.org/records/8327576


# A mock counts and mock metadata with spatial location generated for a 8 genes by 
# 9 cells object is in /extdata: 

starpath <- system.file(
  file.path("extdata", "STARmapPLUS_small"),
  package = "SpatialExperimentIO")

list.files(starpath)

# One of the following depending on your output (`SPE` or `SCE`) requirement.
star_spe <- readStarmapplusSXE(dirName = starpath)
star_sce <- readStarmapplusSXE(dirName = starpath, returnType = "SCE")


}
\author{
Yixing Estella Dong
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/addParquetPaths.R
\name{addParquetPathsCosmx}
\alias{addParquetPathsCosmx}
\title{Add CosMx-related parquet paths to metadata for transcripts, polygon, or cell/nucleus boundaries.}
\usage{
addParquetPathsCosmx(
  sxe,
  dirName,
  addTx = TRUE,
  txMetaNames = "transcripts",
  txPattern = "tx_file.csv",
  addPolygon = TRUE,
  polygonMetaNames = "polygons",
  polygonPattern = "polygons.csv"
)
}
\arguments{
\item{sxe}{a SPE or SCE Xenium object to add parquet to \code{metadata(sxe)}.}

\item{dirName}{the directory that stores the transcripts/polygon
.csv or .parquet files.}

\item{addTx}{to add path to transcripts parquet to \code{metadata(sxe)}or not.
Default is TRUE.}

\item{txMetaNames}{names to add to slots in \code{metadata(sxe)[["name"]]}.
The number of \code{txMetaNames} should equal to number of file detected in \code{dirName}
with \code{txPattern}. Can have multiple, such as \code{c("transcripts", "transcripts1")}.
Default is \code{"transcripts"}.}

\item{txPattern}{.csv or .parquet (if you have previous converted) pattern
of transcript file in \code{dirName}. Can have multiple, such as \code{c("tx_file.csv", "tx_file1.csv")}.
Default value is \code{"tx_file.csv"}.}

\item{addPolygon}{to add path to polygons parquet to \code{metadata(sxe)} or not.
Default is TRUE.}

\item{polygonMetaNames}{names to add to slots in \verb{metadata(sxe)$}. The number of
\code{polygonMetaNames} should equal to number of file detected in \code{dirName} with \code{polygonPattern}.
Can have multiple. Can have multiple, such as \code{c("polygons", "polygons1")}.
Default is \code{"transcripts"}.}

\item{polygonPattern}{.csv or .parquet (if you have previous converted) pattern
of polygons file in the \code{dirName}. Can have multiple, such as \code{c("polygons.csv", "polygons1.csv")}.
Default value is \code{"polygons.csv"}.}
}
\value{
a SPE or SCE Xenium object with parquet paths added to metadata
}
\description{
Add CosMx-related parquet paths to metadata for transcripts, polygon, or cell/nucleus boundaries.
}
\examples{
cospath <- system.file(file.path("extdata", "CosMx_small"), 
                       package = "SpatialExperimentIO")

sxe <- readCosmxSXE(dirName = cospath, addParquetPaths = FALSE)
sxe <- addParquetPathsCosmx(sxe, dirName = cospath, addPolygon = FALSE)

}
\author{
Yixing Estella Dong
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readMerscopeSXE.R
\name{readMerscopeSXE}
\alias{readMerscopeSXE}
\title{Load data from a Vizgen MERSCOPE experiment}
\usage{
readMerscopeSXE(
  dirName = dirName,
  returnType = "SPE",
  countMatPattern = "cell_by_gene.csv",
  metaDataPattern = "cell_metadata.csv",
  coordNames = c("center_x", "center_y")
)
}
\arguments{
\item{dirName}{a directory path to MERSCOPE download that contains files of interest.}

\item{returnType}{option of \code{"SPE"} or \code{"SCE"}, stands for
\code{SpatialExperiment} or \code{SingleCellExperiment} object. Default value \code{"SPE"}}

\item{countMatPattern}{a filename pattern for the count matrix. Default value is
\code{"cell_by_gene.csv"}, and there is no need to change.}

\item{metaDataPattern}{a filename pattern for the metadata .csv file that
contains spatial coords. Default value is \code{"metadata_file.csv"}, and
there is no need to change.}

\item{coordNames}{a vector of two strings specify the spatial coord names.
Default value is \code{c("center_x", "center_y")}, and there is no need to change.}
}
\value{
a \code{\link{SpatialExperiment}} or a \code{\link{SingleCellExperiment}} object
}
\description{
Creates a \code{\link{SpatialExperiment}} from the downloaded MERSCOPE
directory for Vizgen MERSCOPE spatial gene expression data.
}
\details{
The constructor assumes the downloaded MERSCOPE count matrix and metadata in
the same folder with the following structure:
MERSCOPE_folder/ \cr
· | — cell_by_gene.csv \cr
· | — cell_metadata.csv \cr
}
\examples{
# A relatively small data download can be from:
# https://console.cloud.google.com/storage/browser/vz-ffpe-showcase/
# HumanOvarianCancerPatient2Slice2?pageState=(\%22StorageObjectListTable\%22:
# (\%22f\%22:\%22\%255B\%255D\%22))&prefix=&forceOnObjectsSortingFiltering=false


# A mock counts and mock metadata with spatial location generated for a 9 genes by 
# 8 cells object is in /extdata: 

merpath <- system.file(
  file.path("extdata", "MERSCOPE_small"),
  package = "SpatialExperimentIO")
  
list.files(merpath)

# One of the following depending on your output (`SPE` or `SCE`) requirement.
mer_spe <- readMerscopeSXE(dirName = merpath)
mer_sce <- readMerscopeSXE(dirName = merpath, returnType = "SCE")


}
\author{
Yixing Estella Dong
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{addParquetPathToMeta}
\alias{addParquetPathToMeta}
\title{Add parquet paths to metadata for transcripts, polygon, or cell/nucleus boundaries.}
\usage{
addParquetPathToMeta(
  sxe,
  dirName = dirName,
  metaNames = "transcripts",
  filePattern = "tx_file.csv"
)
}
\arguments{
\item{sxe}{a SPE or SCE object to add parquet to \code{metadata(sxe)}.}

\item{dirName}{the directory that stores the transcripts/polygon/cell_boundaries
.csv or .parquet files.}

\item{metaNames}{a vector of names to \code{metadata(sxe)[[]]}. The length must
match number of files detected with filePattern provided.
\code{e.g. c("transcripts", "transcripts1.csv")}.}

\item{filePattern}{a vector of file patterns to search in the current directory.
e.g. \code{c("tx_file.csv", "tx_file1.csv")}.}
}
\value{
a SPE or SCE object with parquet paths added to metadata
}
\description{
Add parquet paths to metadata for transcripts, polygon, or cell/nucleus boundaries.
}
\examples{
dir <- system.file(file.path("extdata", "CosMx_small"),
                   package = "SpatialExperimentIO")
sxe <- readCosmxSXE(dir, addParquetPaths = FALSE)
sxe <- addParquetPathToMeta(sxe,
                            dirName = dir,
                            metaNames = "transcripts",
                            filePattern = "tx_file.parquet")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readXeniumSXE.R
\name{readXeniumSXE}
\alias{readXeniumSXE}
\title{Load data from a 10x Geonomics Xenium experiment}
\usage{
readXeniumSXE(
  dirName,
  returnType = "SPE",
  countMatPattern = "cell_feature_matrix.h5",
  metaDataPattern = "cells.parquet",
  coordNames = c("x_centroid", "y_centroid"),
  addExperimentXenium = TRUE,
  altExps = c("NegControlProbe", "UnassignedCodeword", "NegControlCodeword", "antisense",
    "BLANK"),
  addParquetPaths = TRUE,
  ...
)
}
\arguments{
\item{dirName}{a directory path to Xenium Output Bundle download that contains
files of interest.}

\item{returnType}{option of \code{"SPE"} or \code{"SCE"}, stands for
\code{SpatialExperiment} or \code{SingleCellExperiment} object. Default value \code{"SPE"}}

\item{countMatPattern}{a folder directory or the h5 file pattern for the count matrix.
Default value is \code{"cell_feature_matrix.h5"}, alternative value is
\code{"cell_feature_matrix"} that takes a bit longer. The count matrix is
read in and stored in a \code{SingleCellExperiment} object, using
\code{DropletUtils::read10xCounts()}}

\item{metaDataPattern}{a filename pattern of the zipped .csv file that
contains spatial coords. Default value is \code{"cells.csv.gz"}, and there is no
need to change.}

\item{coordNames}{a vector of two strings specify the spatial coord names.
Default value is \code{c("x_centroid", "y_centroid")}, and there is no need to change.}

\item{addExperimentXenium}{to add experiment.xenium parameters to \code{metadata(sxe)} or not.
Default value is TRUE.}

\item{altExps}{gene names contains these strings will be moved to \code{altExps(sxe)} as separate sxe-s.
Default is \code{c("NegControlProbe", "UnassignedCodeword", "NegControlCodeword", "antisense", "BLANK")}.}

\item{addParquetPaths}{to add parquet paths to \code{metadata(sxe)} or not. If TRUE,
transcripts, cell_boundaries, and nucleus_boundaries .parquet paths will be added to \code{metadata()}.
If, for instance, no cell_boundaries file is available, and transcript and nucleus_boundaries
files are available, please set this argument to TRUE and adjust \code{addCellBound = FALSE}
in the \code{...} argument. Default is TRUE.}

\item{...}{extra parameters to pass to \code{\link{addParquetPathsXenium}()}, including
\code{addTx}, \code{txMetaNames}, \code{txPattern}, \code{addCellBound}, \code{cellBoundMetaNames},
\code{cellBoundPattern}, \code{addNucBound}, \code{NucBoundMetaNames}, \code{NucBoundPattern}.}
}
\value{
a \code{\link{SpatialExperiment}} or a \code{\link{SingleCellExperiment}} object
}
\description{
Creates a \code{\link{SpatialExperiment}} from the downloaded unzipped Xenium
Output Bundle directory for 10x Genomics Xenium spatial gene expression data.
}
\details{
The constructor assumes the downloaded unzipped Xenium Output Bundle has the
following structure, with mandatory file of cells.csv.gz and either folder
/cell_feature_matrix or .h5 file cell_feature_matrix.h5:
Xenium_unzipped \cr
· | — cell_feature_matrix.h5 \cr
· | — cell_feature_matrix \cr
· · | - barcodes.tsv.gz \cr
· · | - features.tsv.gz \cr
· · | - matrix.mtx.gz \cr
· | — cells.parquet \cr

Optional files to add to the metadata() as a list of paths (will be converted to parquet):
· | — transcripts.parquet \cr
· | — cell_boundaries.parquet \cr
· | — nucleus_boundaries.parquet \cr
· | — experiment.xenium \cr
See addParquetPathsXenium()
}
\examples{
# A relatively small data set is the Xenium mouse brain data that can be 
# downloaded from 10X website.

# A mock .h5 and mock metadata with spatial location generated for a 4 genes by 
# 6 cells object is in /extdata: 

xepath <- system.file(
  file.path("extdata", "Xenium_small"),
  package = "SpatialExperimentIO")
  
list.files(xepath)

# One of the following depending on your input (.h5 or folder) and output 
# (`SPE` or `SCE`) requirement.
xe_spe <- readXeniumSXE(dirName = xepath)
\dontrun{
xe_spe <- readXeniumSXE(dirName = xepath, countMatPattern = "cell_feature_matrix")
}
xe_sce <- readXeniumSXE(dirName = xepath, returnType = "SCE")

xe_spe <- readXeniumSXE(dirName = xepath, addParquetPaths = TRUE)
xe_spe <- readXeniumSXE(dirName = xepath, addParquetPaths = TRUE, addNucBound = FALSE)

}
\author{
Yixing Estella Dong
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{csvToParquetPaths}
\alias{csvToParquetPaths}
\title{If transcripts or polygon is expected to be loaded, write a parquet file to
the current data download (if not already), and return the file path to .parquet}
\usage{
csvToParquetPaths(dirName, filepath = "tx_csv_path")
}
\arguments{
\item{dirName}{current directory of data download}

\item{filepath}{path to transcripts or polygons csv}
}
\value{
a path to .parquet
}
\description{
If transcripts or polygon is expected to be loaded, write a parquet file to
the current data download (if not already), and return the file path to .parquet
}
\examples{
dir <- system.file(file.path("extdata", "CosMx_small"),
                   package = "SpatialExperimentIO")
tx_csv_path <- file.path(dir, "lung_p9s1_tx_file.csv")
tx_parquet_path <- csvToParquetPaths(dirName, filepath = tx_csv_path)

}
\author{
Yixing Estella Dong
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readCosmxSXE.R
\name{readCosmxSXE}
\alias{readCosmxSXE}
\title{Load data from a Nanostring CosMx experiment}
\usage{
readCosmxSXE(
  dirName = dirName,
  returnType = "SPE",
  countMatPattern = "exprMat_file.csv",
  metaDataPattern = "metadata_file.csv",
  coordNames = c("CenterX_global_px", "CenterY_global_px"),
  addFovPos = TRUE,
  fovPosPattern = "fov_positions_file.csv",
  altExps = c("NegPrb", "Negative", "SystemControl", "FalseCode"),
  addParquetPaths = TRUE,
  ...
)
}
\arguments{
\item{dirName}{a directory path to CosMx download that contains files of interest.}

\item{returnType}{option of \code{"SPE"} or \code{"SCE"}, stands for
\code{SpatialExperiment} or \code{SingleCellExperiment} object. Default value \code{"SPE"}}

\item{countMatPattern}{a filename pattern for the count matrix. Default value is
\code{"exprMat_file.csv"}, and there is no need to change.}

\item{metaDataPattern}{a filename pattern for the metadata .csv file that
contains spatial coords. Default value is \code{"metadata_file.csv"}, and
there is no need to change.}

\item{coordNames}{a vector of two strings specify the spatial coord names.
Default value is \code{c("CenterX_global_px", "CenterY_global_px")}, and
there is no need to change.}

\item{addFovPos}{to read in fov_position_list.csv and add the data frame to
\code{metadata(sxe)$fov_positions} or not. Default is TRUE.}

\item{fovPosPattern}{.csv pattern of fov_position_list.csv files in the raw download.
Default value is \code{"fov_positions_file.csv"}.}

\item{altExps}{gene names contains these strings will be moved to \code{altExps(sxe)}
as separate sxe-s. Default is \code{c("NegPrb", "Negative", "SystemControl", "FalseCode")}.}

\item{addParquetPaths}{to add parquet paths to \code{metadata(sxe)} or not. If TRUE,
transcripts and polygon .csv files will be converted to .parquet, and the paths
will be added. If, for instance, no polygon file is available, and only transcript
file is available, please set this argument to TRUE and adjust \code{addPolygon = FALSE}
in the \code{...} argument. Default is TRUE.}

\item{...}{extra parameters to pass to \code{\link{addParquetPathsCosmx}()}, including
\code{addTx}, \code{txMetaNames}, \code{txPattern}, \code{addPolygon}, \code{polygonMetaNames},
\code{polygonPattern}.}
}
\value{
a \code{\link{SpatialExperiment}} or a \code{\link{SingleCellExperiment}} object
}
\description{
Creates a \code{\link{SpatialExperiment}} from the downloaded unzipped CosMx
directory for Nanostring CosMx spatial gene expression data.
}
\details{
The constructor assumes the downloaded unzipped CosMx folder has the following
structure, with two mandatory files:
CosMx_unzipped/optional_default_folder/ \cr
· | — *_exprMat_file.csv \cr
· | — *_metadata_file.csv \cr

Optional files to add to the metadata() as a list of paths (will be converted to parquet):
· | — *_fov_positions_file.csv \cr
· | — *_tx_file.csv \cr
· | — *_polygons.csv \cr
If no optional files, need to set \code{addFovPos = FALSE} and \code{addParquetPaths = FALSE}.
If only one of \verb{*_tx_file.csv} or \verb{*_polygons.csv} exists, set \code{addParquetPaths = TRUE} but
set the not available \code{addTx} or \code{addPolygon} to \code{FALSE}.
See \code{\link{addParquetPathsCosmx}()}
}
\examples{
# A relatively small data download can be from:
# https://nanostring.com/resources/smi-ffpe-dataset-lung9-rep1-data/


# A mock counts and mock metadata with spatial location generated for a 8 genes by 
# 9 cells object is in /extdata: 

cospath <- system.file(
  file.path("extdata", "CosMx_small"),
  package = "SpatialExperimentIO")
  
list.files(cospath)

# One of the following depending on your output (`SPE` or `SCE`) requirement.
cos_spe <- readCosmxSXE(dirName = cospath, addPolygon = FALSE)
cos_sce <- readCosmxSXE(dirName = cospath, returnType = "SCE", addPolygon = FALSE)
cos_spe <- readCosmxSXE(dirName = cospath, addParquetPaths = FALSE)


}
\author{
Yixing Estella Dong
}
